/*
 * Copyright 1998-2003 VIA Technologies, Inc. All Rights Reserved.
 * Copyright 2001-2003 S3 Graphics, Inc. All Rights Reserved.
 *
 * Permission is hereby granted, free of charge, to any person
 * obtaining a copy of this software and associated documentation
 * files (the "Software"), to deal in the Software without
 * restriction, including without limitation the rights to use,
 * copy, modify, merge, publish, distribute, sub license,
 * and/or sell copies of the Software, and to permit persons to
 * whom the Software is furnished to do so, subject to the
 * following conditions:
 *
 * The above copyright notice and this permission notice
 * (including the next paragraph) shall be included in all
 * copies or substantial portions of the Software.
 *
 * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND,
 * EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES
 * OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND
 * NON-INFRINGEMENT. IN NO EVENT SHALL VIA, S3 GRAPHICS, AND/OR
 * ITS SUPPLIERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
 * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE,
 * ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR
 * THE USE OR OTHER DEALINGS IN THE SOFTWARE.
 */

#include "via_chrome9_drv.h"
#include "via_chrome9_cursor.h"
#include "via_chrome9_display_common.h"
#include "via_chrome9_object.h"
#include "via_chrome9_mode.h"

struct via_pll_map via_chrome9_pll_value[] = {
	{ CLK_14_887M, PLL3NEW_14_887M, PLL3ADV_14_887M },
	{ CLK_17_857M, PLL3NEW_17_857M, PLL3ADV_17_857M },
	{ CLK_17_897M, PLL3NEW_17_897M, PLL3ADV_17_897M },
	{ CLK_25_175M, PLL3NEW_25_175M, PLL3ADV_25_175M },
	{ CLK_26_719M, PLL3NEW_26_719M, PLL3ADV_26_719M },
	{ CLK_27_000M, PLL3NEW_27_000M, PLL3ADV_27_000M },
	{ CLK_27_027M, PLL3NEW_27_027M, PLL3ADV_27_027M },
	{ CLK_28_274M, PLL3NEW_28_274M, PLL3ADV_28_274M },
	{ CLK_29_201M, PLL3NEW_29_201M, PLL3ADV_29_201M },
	{ CLK_29_581M, PLL3NEW_29_581M, PLL3ADV_29_581M },
	{ CLK_31_490M, PLL3NEW_31_490M, PLL3ADV_31_490M },
	{ CLK_31_500M, PLL3NEW_31_500M, PLL3ADV_31_500M },
	{ CLK_31_728M, PLL3NEW_31_728M, PLL3ADV_31_728M },
	{ CLK_32_668M, PLL3NEW_32_668M, PLL3ADV_32_668M },
	{ CLK_33_750M, PLL3NEW_33_750M, PLL3ADV_33_750M },
	{ CLK_36_000M, PLL3NEW_36_000M, PLL3ADV_36_000M },
	{ CLK_40_000M, PLL3NEW_40_000M, PLL3ADV_40_000M },
	{ CLK_41_291M, PLL3NEW_41_291M, PLL3ADV_41_291M },
	{ CLK_43_125M, PLL3NEW_43_125M, PLL3ADV_43_125M },
	{ CLK_43_163M, PLL3NEW_43_163M, PLL3ADV_43_163M },
	{ CLK_46_000M, PLL3NEW_46_000M, PLL3ADV_46_000M },
	{ CLK_46_996M, PLL3NEW_46_996M, PLL3ADV_46_996M },
	{ CLK_47_193M, PLL3NEW_47_193M, PLL3ADV_47_193M },
	{ CLK_48_000M, PLL3NEW_48_000M, PLL3ADV_48_000M },
	{ CLK_48_875M, PLL3NEW_48_875M, PLL3ADV_48_875M },
	{ CLK_49_500M, PLL3NEW_49_500M, PLL3ADV_49_500M },
	{ CLK_52_375M, PLL3NEW_52_375M, PLL3ADV_52_375M },
	{ CLK_52_406M, PLL3NEW_52_406M, PLL3ADV_52_406M },
	{ CLK_52_977M, PLL3NEW_52_977M, PLL3ADV_52_977M },
	{ CLK_56_250M, PLL3NEW_56_250M, PLL3ADV_56_250M },
	{ CLK_60_466M, PLL3NEW_60_466M, PLL3ADV_60_466M },
	{ CLK_61_500M, PLL3NEW_61_500M, PLL3ADV_61_500M },
	{ CLK_65_000M, PLL3NEW_65_000M, PLL3ADV_65_000M },
	{ CLK_65_178M, PLL3NEW_65_178M, PLL3ADV_65_178M },
	{ CLK_67_295M, PLL3NEW_67_295M, PLL3ADV_67_295M },
	{ CLK_68_125M, PLL3NEW_68_125M, PLL3ADV_68_125M },
	{ CLK_68_179M, PLL3NEW_68_179M, PLL3ADV_68_179M },
	{ CLK_68_900M, PLL3NEW_68_900M, PLL3ADV_68_900M },
	{ CLK_69_924M, PLL3NEW_69_924M, PLL3ADV_69_924M },
	{ CLK_70_159M, PLL3NEW_70_159M, PLL3ADV_70_159M },
	{ CLK_72_000M, PLL3NEW_72_000M, PLL3ADV_72_000M },
	{ CLK_74_250M, PLL3NEW_74_250M, PLL3ADV_74_250M },
	{ CLK_74_481M, PLL3NEW_74_481M, PLL3ADV_74_481M },
	{ CLK_78_750M, PLL3NEW_78_750M, PLL3ADV_78_750M },
	{ CLK_78_800M, PLL3NEW_78_800M, PLL3ADV_78_800M },
	{ CLK_79_500M, PLL3NEW_79_500M, PLL3ADV_79_500M },
	{ CLK_80_136M, PLL3NEW_80_136M, PLL3ADV_80_136M },
	{ CLK_83_375M, PLL3NEW_83_375M, PLL3ADV_83_375M },
	{ CLK_83_500M, PLL3NEW_83_500M, PLL3ADV_83_500M },
	{ CLK_83_950M, PLL3NEW_83_950M, PLL3ADV_83_950M },
	{ CLK_84_000M, PLL3NEW_84_000M, PLL3ADV_84_000M },
	{ CLK_84_750M, PLL3NEW_84_750M, PLL3ADV_84_750M },
	{ CLK_85_500M, PLL3NEW_85_500M, PLL3ADV_85_500M },
	{ CLK_85_875M, PLL3NEW_85_875M, PLL3ADV_85_875M },
	{ CLK_94_500M, PLL3NEW_94_500M, PLL3ADV_94_500M },
	{ CLK_95_750M, PLL3NEW_95_750M, PLL3ADV_95_750M },
	{ CLK_106_500M, PLL3NEW_106_500M, PLL3ADV_106_500M },
	{ CLK_107_214M, PLL3NEW_107_214M, PLL3ADV_107_214M },
	{ CLK_108_000M, PLL3NEW_108_000M, PLL3ADV_108_000M },
	{ CLK_113_250M, PLL3NEW_113_250M, PLL3ADV_113_250M },
	{ CLK_118_840M, PLL3NEW_118_840M, PLL3ADV_118_840M },
	{ CLK_121_750M, PLL3NEW_121_750M, PLL3ADV_121_750M },
	{ CLK_122_500M, PLL3NEW_122_500M, PLL3ADV_122_500M },
	{ CLK_126_266M, PLL3NEW_126_266M, PLL3ADV_126_266M },
	{ CLK_132_750M, PLL3NEW_132_750M, PLL3ADV_132_750M },
	{ CLK_133_308M, PLL3NEW_133_308M, PLL3ADV_133_308M },
	{ CLK_135_000M, PLL3NEW_135_000M, PLL3ADV_135_000M },
	{ CLK_136_700M, PLL3NEW_136_700M, PLL3ADV_136_700M },
	{ CLK_138_400M, PLL3NEW_138_400M, PLL3ADV_138_400M },
	{ CLK_146_250M, PLL3NEW_146_250M, PLL3ADV_146_250M },
	{ CLK_148_500M, PLL3NEW_148_500M, PLL3ADV_148_500M },
	{ CLK_153_920M, PLL3NEW_153_920M, PLL3ADV_153_920M },
	{ CLK_154_000M, PLL3NEW_154_000M, PLL3ADV_154_000M },
	{ CLK_154_600M, PLL3NEW_154_600M, PLL3ADV_154_600M },
	{ CLK_157_500M, PLL3NEW_157_500M, PLL3ADV_157_500M },
	{ CLK_162_000M, PLL3NEW_162_000M, PLL3ADV_162_000M },
	{ CLK_172_798M, PLL3NEW_172_798M, PLL3ADV_172_798M },
	{ CLK_187_000M, PLL3NEW_187_000M, PLL3ADV_187_000M },
	{ CLK_193_250M, PLL3NEW_193_250M, PLL3ADV_193_250M },
	{ CLK_202_500M, PLL3NEW_202_500M, PLL3ADV_202_500M },
	{ CLK_204_000M, PLL3NEW_204_000M, PLL3ADV_204_000M },
	{ CLK_204_750M, PLL3NEW_204_750M, PLL3ADV_204_750M },
	{ CLK_214_750M, PLL3NEW_214_750M, PLL3ADV_214_750M },
	{ CLK_218_250M, PLL3NEW_218_250M, PLL3ADV_218_250M },
	{ CLK_218_500M, PLL3NEW_218_500M, PLL3ADV_218_500M },
	{ CLK_220_750M, PLL3NEW_220_750M, PLL3ADV_220_750M },
	{ CLK_234_000M, PLL3NEW_234_000M, PLL3ADV_234_000M },
	{ CLK_234_586M, PLL3NEW_234_586M, PLL3ADV_234_586M },
	{ CLK_234_763M, PLL3NEW_234_763M, PLL3ADV_234_763M },
	{ CLK_245_250M, PLL3NEW_245_250M, PLL3ADV_245_250M },
	{ CLK_246_500M, PLL3NEW_246_500M, PLL3ADV_246_500M },
	{ CLK_267_250M, PLL3NEW_267_250M, PLL3ADV_267_250M },
	{ CLK_297_000M, PLL3NEW_297_000M, PLL3ADV_297_000M },
	{ CLK_297_500M, PLL3NEW_297_500M, PLL3ADV_297_500M },
};

#define NUM_TOTAL_PLL_TABLE CMDISP_ARRAYSIZE(via_chrome9_pll_value)

static struct vpit_reg_table vpit_regs = {
	/* Msic */
	0xCF,
	/* Sequencer */
	{ 0x01, 0x0F, 0x00, 0x0E },
	/* Graphic Controller */
	{ 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x05, 0x0F, 0xFF },
	/* Attribute Controller */
	{ 0x00, 0x01, 0x02, 0x03, 0x04, 0x05, 0x06, 0x07,
	0x08, 0x09, 0x0A, 0x0B, 0x0C, 0x0D, 0x0E, 0x0F,
	0x01, 0x00, 0x0F, 0x00 }
};

static struct iga1_crtc_timing_regs iga1_crtc_regs = {
	/* IGA1 Horizontal Total */
	{ VIA_IGA1_HOR_TOTAL_REG_NUM, { { REG_CR00, 0, 7 },
		{ REG_CR36, 3, 3 } } },
	/* IGA1 Horizontal Addressable Video */
	{ VIA_IGA1_HOR_ADDR_REG_NUM, { { REG_CR01, 0, 7 },
		{ REG_CR45, 1, 1 } } },
	/* IGA1 Horizontal Blank Start */
	{ VIA_IGA1_HOR_BLANK_START_REG_NUM,
		{ { REG_CR02, 0, 7 }, { REG_CR45, 2, 2 } } },
	/* IGA1 Horizontal Blank End */
	{ VIA_IGA1_HOR_BLANK_END_REG_NUM, { { REG_CR03, 0, 4 },
		{ REG_CR05, 7, 7 }, { REG_CR33, 5, 5 } } },
	/* IGA1 Horizontal Sync Start */
	{ VIA_IGA1_HOR_SYNC_START_REG_NUM,
		{ { REG_CR04, 0, 7 }, { REG_CR33, 4, 4 } } },
	/* IGA1 Horizontal Sync End */
	{ VIA_IGA1_HOR_SYNC_END_REG_NUM, { { REG_CR05, 0, 4 } } },
	/* IGA1 Vertical Total */
	{ VIA_IGA1_VER_TOTAL_REG_NUM, { { REG_CR06, 0, 7 }, { REG_CR07, 0, 0 },
		{ REG_CR07, 5, 5 }, { REG_CR35, 0, 0 } } },
	/* IGA1 Vertical Addressable Video */
	{ VIA_IGA1_VER_ADDR_REG_NUM, { { REG_CR12, 0, 7 }, { REG_CR07, 1, 1 },
		{ REG_CR07, 6, 6 }, { REG_CR35, 2, 2 } } },
	/* IGA1 Vertical Blank Start */
	{ VIA_IGA1_VER_BLANK_START_REG_NUM, { { REG_CR15, 0, 7 },
		{ REG_CR07, 3, 3 }, { REG_CR09, 5, 5 }, { REG_CR35, 3, 3 } } },
	/* IGA1 Vertical Blank End */
	{ VIA_IGA1_VER_BLANK_END_REG_NUM, { { REG_CR16, 0, 7 } } },
	/* IGA1 Vertical Sync Start */
	{ VIA_IGA1_VER_SYNC_START_REG_NUM, { { REG_CR10, 0, 7 },
		{ REG_CR07, 2, 2 }, { REG_CR07, 7, 7 }, { REG_CR35, 1, 1 } } },
	/* IGA1 Vertical Sync End */
	{ VIA_IGA1_VER_SYNC_END_REG_NUM, { { REG_CR11, 0, 3 } } }
};

static struct iga2_crtc_timing_regs iga2_crtc_regs = {
	/* IGA2 Horizontal Total */
	{ VIA_IGA2_HOR_TOTAL_REG_NUM, { { REG_CR50, 0, 7 },
		{ REG_CR55, 0, 3 } } },
	/* IGA2 Horizontal Addressable Video */
	{ VIA_IGA2_HOR_ADDR_REG_NUM, { { REG_CR51, 0, 7 }, { REG_CR55, 4, 6 },
		{ REG_CR55, 7, 7 } } },
	/* IGA2 Horizontal Blank Start*/
	{ VIA_IGA2_HOR_BLANK_START_REG_NUM, { { REG_CR52, 0, 7 },
		{ REG_CR54, 0, 2 }, { REG_CR6B, 0, 0 } } },
	/* IGA2 Horizontal Blank End */
	{ VIA_IGA2_HOR_BLANK_END_REG_NUM, { { REG_CR53, 0, 7 },
		{ REG_CR54, 3, 5 }, { REG_CR5D, 6, 6 } } },
	/* IGA2 Horizontal Sync Start */
	{ VIA_IGA2_HOR_SYNC_START_REG_NUM, { { REG_CR56, 0, 7 },
		{ REG_CR54, 6, 7 }, { REG_CR5C, 7, 7 }, { REG_CR5D, 7, 7 } } },
	/* IGA2 Horizontal Sync End */
	{ VIA_IGA2_HOR_SYNC_END_REG_NUM, { { REG_CR57, 0, 7 },
		{ REG_CR5C, 6, 6 } } },
	/* IGA2 Vertical Total */
	{ VIA_IGA2_VER_TOTAL_REG_NUM, { { REG_CR58, 0, 7 },
		{ REG_CR5D, 0, 2 } } },
	/* IGA2 Vertical Addressable Video */
	{ VIA_IGA2_VER_ADDR_REG_NUM, { { REG_CR59, 0, 7 },
		{ REG_CR5D, 3, 5 } } },
	/* IGA2 Vertical Blank Start */
	{ VIA_IGA2_VER_BLANK_START_REG_NUM,
		{ { REG_CR5A, 0, 7 }, { REG_CR5C, 0, 2 } } },
	/* IGA2 Vertical Blank End */
	{ VIA_IGA2_VER_BLANK_END_REG_NUM, { { REG_CR5B, 0, 7 },
		{ REG_CR5C, 3, 5 } } },
	/* IGA2 Vertical Sync Start */
	{ VIA_IGA2_VER_SYNC_START_REG_NUM,
		{ { REG_CR5E, 0, 7 }, { REG_CR5F, 5, 7 } } },
	/* IGA2 Vertical Sync End */
	{ VIA_IGA2_VER_SYNC_END_REG_NUM, { { REG_CR5F, 0, 4 } } }
};

static struct via_offset_regs via_chrome9_offset_regs = {
	/* IGA Offset Register */
	{ VIA_IGA1_OFFSET_REG_NUM, { { REG_CR13, 0, 7 }, { REG_CR35, 5, 7 } } },
	/* IGA2 Offset Register */
	{ VIA_IGA2_OFFSET_REG_NUM, { { REG_CR66, 0, 7 }, { REG_CR67, 0, 1 } } }
};

static struct via_iga2_offset_13bit_regs via_chrome9_iga2_offset_13bit_regs = {
	VIA_IGA2_OFFSET_13BIT_REG_NUM, { { REG_CR66, 0, 7 },
		{ REG_CR67, 0, 1 }, { REG_CR71, 7, 7 } }
};

static struct via_iga_fetch_count_regs via_chrome9_fetch_count_regs = {
	/* IGA Fetch Count Register */
	{ VIA_IGA1_FETCH_COUNT_REG_NUM, { { REG_SR1C, 0, 7 },
		{ REG_SR1D, 0, 1 } } },
	/* IGA2 Fetch Count Register */
	{ VIA_IGA2_FETCH_COUNT_REG_NUM, { { REG_CR65, 0, 7 },
		{ REG_CR67, 2, 3 } } }
};

static struct via_disp_fifo via_chrome9_disp_fifo_table[] = {
	/* Chip                 IGA1 FIFO             IGA2 FIFO */
	{ VX800_DEVICE, { 192, 152, 152,  64 }, {  96,  76,  76, 128 } },
	{ VX855_DEVICE, { 400, 320, 320, 160 }, { 200, 160, 160, 320 } },
	{ VX900_DEVICE, { 400, 320, 320, 160 }, { 192, 160, 160, 320 } }
};

#define NUM_TOTAL_DISP_FIFO_TABLE CMDISP_ARRAYSIZE(via_chrome9_disp_fifo_table)

static struct via_fifo_depth_select via_chrome9_display_fifo_depth_reg = {
	/* IGA1 FIFO Depth_Select */
	{ VIA_IGA1_FIFO_DEPTH_SELECT_REG_NUM, { { REG_SR17, 0, 7 } } },
	/* IGA2 FIFO Depth_Select */
	{ VIA_IGA2_FIFO_DEPTH_SELECT_REG_NUM,
	{ { REG_CR68, 4, 7 }, { REG_CR94, 7, 7 },
	{ REG_CR95, 7, 7 } } }
};

static struct via_fifo_threshold_select
	via_chrome9_fifo_threshold_select_reg = {
	/* IGA1 FIFO Threshold Select */
	{ VIA_IGA1_FIFO_THRESHOLD_REG_NUM,
		{ { REG_SR16, 0, 5 }, { REG_SR16, 7, 7 } } },
	/* IGA2 FIFO Threshold Select */
	{ VIA_IGA2_FIFO_THRESHOLD_REG_NUM, { { REG_CR68, 0, 3 },
		{ REG_CR95, 4, 6 } } }
};

static struct via_fifo_high_threshold_select
	via_chrome9_fifo_high_threshold_select_reg = {
	/* IGA1 GFX PREG Thresold Select */
	{ VIA_IGA1_FIFO_HIGH_THRESHOLD_REG_NUM,
		{ { REG_SR18, 0, 5 }, { REG_SR18, 7, 7 } } },
	/* IGA2 GFX PREG Thresold Select */
	{ VIA_IGA2_FIFO_HIGH_THRESHOLD_REG_NUM,
		{ { REG_CR92, 0, 3 }, { REG_CR95, 0, 2 } } }
};

static struct via_display_queue_expire_num
	via_chrome9_display_queue_expire_num_reg = {
	/* IGA1 Display Queue Expire Num */
	{ VIA_IGA1_DISPLAY_QUEUE_EXPIRE_NUM_REG_NUM, { { REG_SR22, 0, 4 },
		{ REG_SR57, 6, 6 } } },
	/* IGA2 Display Queue Expire Num */
	{ VIA_IGA2_DISPLAY_QUEUE_EXPIRE_NUM_REG_NUM, { { REG_CR94, 0, 6 } } }
};

static struct lcd_scaling_regs via_lcd_scaling_regs = {
	/* Hor Scaling Register */
	{ LCD_HOR_SCALING_REG_NUM, { { REG_CR9F, 0, 1 },
		{ REG_CR77, 0, 7 }, { REG_CR79, 4, 5 } } },
	{ LCD_VER_SCALING_REG_NUM, { { REG_CR79, 3, 3 },
		{ REG_CR78, 0, 7 }, { REG_CR79, 6, 7 } } }
};


/*
 * Function Name: via_chrome9_unlock_crtc
 * Description: Unlock CRTC register
 * Parameters:
 * IN:
 * OUT:
 * Status Return:
 * Note:
 * */
void via_chrome9_unlock_crtc(struct drm_device *dev)
{
	struct drm_via_chrome9_private *p_priv =
		(struct drm_via_chrome9_private *)dev->dev_private;

	via_chrome9_write_vga_io_bits(REG_CR11, 0, BIT7);
	if (p_priv->pseudo_chip_revision >= REVISION_VX855_A1)
		/*this set is only for vx855 A1and later mb*/
		via_chrome9_write_vga_io_bits(REG_CR47, 0, BIT4);
	else
		via_chrome9_write_vga_io_bits(REG_CR47, 0, BIT0);
}

/*
 * Function Name: via_chrome9_lock_crtc
 * Description: Lock CRTC register
 * Parameters:
 * IN:
 * OUT:
 * Status Return:
 * Note:
 * */
void via_chrome9_lock_crtc(void)
{
	via_chrome9_write_vga_io_bits(REG_CR11, BIT7, BIT7);
}

void via_chrome9_iga1_hw_reset_enable(struct drm_device *dev)
{
	/* HW Reset Enable, CR17[7] = 0 */
	via_chrome9_write_vga_io_bits(REG_CR17, 0x00, BIT7);
}

void via_chrome9_iga1_hw_reset_disable(struct drm_device *dev)
{
	unsigned long i = 0, max_loop = 50;
	while ((via_chrome9_read_vga_io(REG_SR3C) & BIT3) == 0
		&& i++ < max_loop)
		via_chrome9_delay_msec(dev, 20);

	/* HW Reset Disable, CR17[7] = 1 */
	via_chrome9_write_vga_io_bits(REG_CR17, BIT7, BIT7);
}

/*
* via_chrome9_iga2_hw_reset_enable
* This function reset IGA2, clear IGA2 fetch counter
* N :
* NONE
* OUT :
* NONE
* */
void via_chrome9_iga2_hw_reset_enable(struct drm_device *dev)
{
	/* IGA2 HW Reset Enable, CR6A[6] = 0 */
	via_chrome9_write_vga_io_bits(REG_CR6A, 0x00, BIT6);
}

/*
* via_chrome9_iga2_hw_reset_disable
* This function disable reset IGA2, clear IGA2 fetch counter
* IN :
* NONE
* OUT :
* NONE
**/
void via_chrome9_iga2_hw_reset_disable(struct drm_device *dev)
{
	unsigned long i = 0, max_loop = 50;
	while ((via_chrome9_read_vga_io(REG_SR3C) & BIT2) == 0
		&& i++ < max_loop)
		via_chrome9_delay_msec(dev, 20);

	/* IGA2 HW Reset Disble, CR6A[6] = 1 */
	via_chrome9_write_vga_io_bits(REG_CR6A, BIT6, BIT6);
}

/*
    Function Name:  via_chrome9_load_fixed_crtc_regs
    Description: Load fixed CRTC timing registers
*/
void via_chrome9_load_fixed_crtc_regs(struct drm_device *dev)
{
	via_chrome9_unlock_crtc(dev);
	/* always set to 1 */
	via_chrome9_write_vga_io_bits(REG_CR03, 0x80, BIT7);
	/* line compare should set all bits = 1 (extend modes) */
	via_chrome9_write_vga_io(REG_CR18, 0xFF);
	via_chrome9_write_vga_io_bits(REG_CR07, 0x10, BIT4);
	via_chrome9_write_vga_io_bits(REG_CR09, 0x40, 0xFF);
	via_chrome9_write_vga_io_bits(REG_CR35, 0x10, BIT4);
	via_chrome9_write_vga_io_bits(REG_CR33, 0x05, BIT0 + BIT1 + BIT2);
	/* extend mode always set to e3h */
	via_chrome9_write_vga_io(REG_CR17, 0xE3);
	/* extend mode always set to 0h */
	via_chrome9_write_vga_io(REG_CR08, 0x00);
	/* extend mode always set to 0h */
	via_chrome9_write_vga_io(REG_CR14, 0x00);

	via_chrome9_lock_crtc();
}

/* Get the timing information which will be
*   flushed into HW from the given mode
*/
bool via_chrome9_get_timing_info_from_mode(
		struct drm_display_mode *adjusted_mode,
		struct display_timing_table *p_timing)
{
	if (NULL == adjusted_mode)
		return false;

	p_timing->timing.hor_total = adjusted_mode->crtc_htotal;
	p_timing->timing.hor_addr = adjusted_mode->crtc_hdisplay;
	p_timing->timing.hor_blank_start = adjusted_mode->crtc_hblank_start;
	p_timing->timing.hor_blank_end = adjusted_mode->crtc_hblank_end;
	p_timing->timing.hor_sync_start = adjusted_mode->crtc_hsync_start;
	p_timing->timing.hor_sync_end = adjusted_mode->crtc_hsync_end;
	p_timing->timing.ver_total = adjusted_mode->crtc_vtotal;
	p_timing->timing.ver_addr = adjusted_mode->crtc_vdisplay;
	p_timing->timing.ver_blank_start = adjusted_mode->crtc_vblank_start;
	p_timing->timing.ver_blank_end = adjusted_mode->crtc_vblank_end;
	p_timing->timing.ver_sync_start = adjusted_mode->crtc_vsync_start;
	p_timing->timing.ver_sync_end = adjusted_mode->crtc_vsync_end;

	p_timing->clk = adjusted_mode->clock * 1000;

	if (adjusted_mode->flags & DRM_MODE_FLAG_PHSYNC)
		p_timing->hsync_polarity = POSITIVE;
	else if (adjusted_mode->flags & DRM_MODE_FLAG_NHSYNC)
		p_timing->hsync_polarity = NEGATIVE;

	if (adjusted_mode->flags & DRM_MODE_FLAG_PVSYNC)
		p_timing->vsync_polarity = POSITIVE;
	else if (adjusted_mode->flags & DRM_MODE_FLAG_NVSYNC)
		p_timing->vsync_polarity = NEGATIVE;

	p_timing->refresh_rate = adjusted_mode->vrefresh;

	KMS_DEBUG(" htotal = %d\n", p_timing->timing.hor_total);
	KMS_DEBUG(" hdisplay = %d\n", p_timing->timing.hor_addr);
	KMS_DEBUG(" hor_blank_start = %d\n", p_timing->timing.hor_blank_start);
	KMS_DEBUG(" hor_blank_end = %d\n", p_timing->timing.hor_blank_start);
	KMS_DEBUG(" hor_sync_start = %d\n", p_timing->timing.hor_sync_start);
	KMS_DEBUG(" hor_sync_end = %d\n", p_timing->timing.hor_sync_end);
	KMS_DEBUG(" ver_total = %d\n", p_timing->timing.ver_total);
	KMS_DEBUG(" ver_addr = %d\n", p_timing->timing.ver_addr);
	KMS_DEBUG(" ver_blank_start = %d\n", p_timing->timing.ver_blank_start);
	KMS_DEBUG(" ver_blank_end = %d\n", p_timing->timing.ver_blank_end);
	KMS_DEBUG(" ver_sync_start = %d\n", p_timing->timing.ver_sync_start);
	KMS_DEBUG(" ver_sync_end = %d\n", p_timing->timing.ver_sync_end);
	KMS_DEBUG(" clock = %d\n", p_timing->clk);
	KMS_DEBUG(" refresh rate= %d HZ\n", p_timing->refresh_rate);

	return true;
}


/* Load CRTC timing registers */
void via_chrome9_load_crtc_timing(struct drm_crtc *crtc,
		struct display_timing crtc_timing)
{
	struct drm_device *dev = crtc->dev;
	struct via_chrome9_crtc *via_chrome9_crtc = to_via_chrome9_crtc(crtc);
	int iga_path = via_chrome9_crtc->crtc_id;
	u8 i = 0;
	u8 reg_amount = 0;
	u32 reg_value = 0;

	struct via_chrome9_io_bit *reg = NULL;

	/* Check input variable iga_path */
	if ((iga_path != IGA1) && (iga_path != IGA2))
		return;

	if (VX900_DEVICE == dev->pci_device && IGA1 == iga_path) {
		/* Disable IGA1 shadow timing */
		via_chrome9_write_vga_io_bits(REG_CR45, 0x00, BIT0);
		/* Disable IGA1 pixel timing */
		via_chrome9_write_vga_io_bits(REG_CRFD, 0x00, BIT6 + BIT5);
	}

	for (i = 0; i < 12; i++) {
		if (IGA1 == iga_path) {
			switch (i) {
			case VIA_H_TOTAL_INDEX:
				reg_value =
					VIA_IGA1_HOR_TOTAL_FORMULA(
					crtc_timing.hor_total);
				reg_amount = iga1_crtc_regs.htotal.reg_num;
				reg = iga1_crtc_regs.htotal.reg;
				break;

			case VIA_H_ADDR_INDEX:
				reg_value =
					VIA_IGA1_HOR_ADDR_FORMULA(
					crtc_timing.hor_addr);
				/* VT3410 add IGA1 hor addr reg CR45[1] */
				if (VX900_DEVICE == dev->pci_device)
					reg_amount =
						iga1_crtc_regs.haddr.reg_num;
				else
					reg_amount =
					iga1_crtc_regs.haddr.reg_num - 1;

				reg = iga1_crtc_regs.haddr.reg;
				break;

			case VIA_H_BLANK_START_INDEX:
				reg_value =
					VIA_IGA1_HOR_BLANK_START_FORMULA(
					crtc_timing.hor_blank_start);
				/* VT3410 add IGA1 hor blank start
				reg CR45[2] */
				if (VX900_DEVICE == dev->pci_device)
					reg_amount =
					iga1_crtc_regs.hblank_st.reg_num;
				else
					reg_amount =
					iga1_crtc_regs.hblank_st.reg_num - 1;

				reg = iga1_crtc_regs.hblank_st.reg;
				break;

			case VIA_H_BLANK_END_INDEX:
				reg_value =
					VIA_IGA1_HOR_BLANK_END_FORMULA(
					crtc_timing.hor_blank_end);
				reg_amount = iga1_crtc_regs.hblank_ed.reg_num;
				reg = iga1_crtc_regs.hblank_ed.reg;
				break;

			case VIA_H_SYNC_START_INDEX:
				reg_value =
					VIA_IGA1_HOR_SYNC_START_FORMULA(
					crtc_timing.hor_sync_start);
				reg_amount = iga1_crtc_regs.hsync_st.reg_num;
				reg = iga1_crtc_regs.hsync_st.reg;
				break;

			case VIA_H_SYNC_END_INDEX:
				reg_value =
					VIA_IGA1_HOR_SYNC_END_FORMULA(
					crtc_timing.hor_sync_end);
				reg_amount = iga1_crtc_regs.hsync_ed.reg_num;
				reg = iga1_crtc_regs.hsync_ed.reg;
				break;

			case VIA_V_TOTAL_INDEX:
				reg_value =
					VIA_IGA1_VER_TOTAL_FORMULA(
					crtc_timing.ver_total);
				reg_amount = iga1_crtc_regs.vtotal.reg_num;
				reg = iga1_crtc_regs.vtotal.reg;
				break;

			case VIA_V_ADDR_INDEX:
				reg_value =
					VIA_IGA1_VER_ADDR_FORMULA(
					crtc_timing.ver_addr);
				reg_amount = iga1_crtc_regs.vaddr.reg_num;
				reg = iga1_crtc_regs.vaddr.reg;
				break;

			case VIA_V_BLANK_START_INDEX:
				reg_value =
					VIA_IGA1_VER_BLANK_START_FORMULA(
					crtc_timing.ver_blank_start);
				reg_amount = iga1_crtc_regs.vblank_st.reg_num;
				reg = iga1_crtc_regs.vblank_st.reg;
				break;

			case VIA_V_BLANK_END_INDEX:
				reg_value =
					VIA_IGA1_VER_BLANK_END_FORMULA(
					crtc_timing.ver_blank_end);
				reg_amount = iga1_crtc_regs.vblank_ed.reg_num;
				reg = iga1_crtc_regs.vblank_ed.reg;
				break;

			case VIA_V_SYNC_START_INDEX:
				reg_value =
					VIA_IGA1_VER_SYNC_START_FORMULA(
					crtc_timing.ver_sync_start);
				reg_amount = iga1_crtc_regs.vsync_st.reg_num;
				reg = iga1_crtc_regs.vsync_st.reg;
				break;

			case VIA_V_SYNC_END_INDEX:
				reg_value =
					VIA_IGA1_VER_SYNC_END_FORMULA(
					crtc_timing.ver_sync_end);
				reg_amount = iga1_crtc_regs.vsync_ed.reg_num;
				reg = iga1_crtc_regs.vsync_ed.reg;
				break;
			}
		} else {
			switch (i) {
			case VIA_H_TOTAL_INDEX:
				reg_value =
					VIA_IGA2_HOR_TOTAL_FORMULA(
					crtc_timing.hor_total);
				reg_amount = iga2_crtc_regs.htotal.reg_num;
				reg = iga2_crtc_regs.htotal.reg;
				break;

			case VIA_H_ADDR_INDEX:
				reg_value =
					VIA_IGA2_HOR_ADDR_FORMULA(
					crtc_timing.hor_addr);
				/* VT3410 add IGA2 hor addr reg CR55[7] */
				if (VX900_DEVICE == dev->pci_device)
					reg_amount =
					iga2_crtc_regs.haddr.reg_num;
				else
					reg_amount =
					iga2_crtc_regs.haddr.reg_num - 1;

				reg = iga2_crtc_regs.haddr.reg;
				break;

			case VIA_H_BLANK_START_INDEX:
				reg_value =
					VIA_IGA2_HOR_BLANK_START_FORMULA(
					crtc_timing.hor_blank_start);

				/* VT3410 add IGA2 hor blank
				start reg CR6B[0] */

				if (dev->pci_device == VX900_DEVICE)
					reg_amount =
					iga2_crtc_regs.hblank_st.reg_num;
				else
					reg_amount =
					iga2_crtc_regs.hblank_st.reg_num - 1;

				reg = iga2_crtc_regs.hblank_st.reg;
				break;

			case VIA_H_BLANK_END_INDEX:
				reg_value =
					VIA_IGA2_HOR_BLANK_END_FORMULA(
					crtc_timing.hor_blank_end);
				reg_amount = iga2_crtc_regs.hblank_ed.reg_num;
				reg = iga2_crtc_regs.hblank_ed.reg;
				break;

			case VIA_H_SYNC_START_INDEX:
				reg_value =
					VIA_IGA2_HOR_SYNC_START_FORMULA(
					crtc_timing.hor_sync_start);
				reg_amount = iga2_crtc_regs.hsync_st.reg_num;
				reg = iga2_crtc_regs.hsync_st.reg;
				break;

			case VIA_H_SYNC_END_INDEX:
				reg_value =
					VIA_IGA2_HOR_SYNC_END_FORMULA(
					crtc_timing.hor_sync_end);
				reg_amount = iga2_crtc_regs.hsync_ed.reg_num;
				reg = iga2_crtc_regs.hsync_ed.reg;
				break;

			case VIA_V_TOTAL_INDEX:
				reg_value =
					VIA_IGA2_VER_TOTAL_FORMULA(
					crtc_timing.ver_total);
				reg_amount = iga2_crtc_regs.vtotal.reg_num;
				reg = iga2_crtc_regs.vtotal.reg;
				break;

			case VIA_V_ADDR_INDEX:
				reg_value =
					VIA_IGA2_VER_ADDR_FORMULA(
					crtc_timing.ver_addr);
				reg_amount = iga2_crtc_regs.vaddr.reg_num;
				reg = iga2_crtc_regs.vaddr.reg;
				break;

			case VIA_V_BLANK_START_INDEX:
				reg_value =
					VIA_IGA2_VER_BLANK_START_FORMULA(
					crtc_timing.ver_blank_start);
				reg_amount = iga2_crtc_regs.vblank_st.reg_num;
				reg = iga2_crtc_regs.vblank_st.reg;
				break;

			case VIA_V_BLANK_END_INDEX:
				reg_value =
					VIA_IGA2_VER_BLANK_END_FORMULA(
					crtc_timing.ver_blank_end);
				reg_amount = iga2_crtc_regs.vblank_ed.reg_num;
				reg = iga2_crtc_regs.vblank_ed.reg;
				break;

			case VIA_V_SYNC_START_INDEX:
				reg_value =
					VIA_IGA2_VER_SYNC_START_FORMULA(
					crtc_timing.ver_sync_start);
				reg_amount = iga2_crtc_regs.vsync_st.reg_num;
				reg = iga2_crtc_regs.vsync_st.reg;
				break;

			case VIA_V_SYNC_END_INDEX:
				reg_value =
					VIA_IGA2_VER_SYNC_END_FORMULA(
					crtc_timing.ver_sync_end);
				reg_amount = iga2_crtc_regs.vsync_ed.reg_num;
				reg = iga2_crtc_regs.vsync_ed.reg;
				break;
			}
		}
		via_chrome9_load_regs(reg_value, reg_amount, reg);
	}
}

/* Fill VPIT parameters, write Misc/SR/GR/AR register */
static void via_chrome9_load_vpit_regs(void)
{
	u32 i = 0;
	u8 data = 0;

	/* Switching AR00[5](PAS) to 0 will allow the CPU
	*   to change the palette registers.
	*   Meanwhile, the monitor will be blank.
	*/
	data = STANDVGA_R8(REG_STATUS);
	STANDVGA_W8(REG_ZAR, 0x00);

	/* Fill VPIT Parameters */
	/* Write Misc register */
	STANDVGA_W8(REG_WMISC, vpit_regs.misc);

	/* Write Sequencer */
	for (i = 1; i <= STD_SR_NUM; i++)
		via_chrome9_write_vga_io((REG_SR00 + i), vpit_regs.sr[i - 1]);

	/* Write Graphic Controller */
	for (i = 0; i < STD_GR_NUM; i++)
		via_chrome9_write_vga_io((REG_GR00 + i), vpit_regs.gr[i]);

	/* Write Attribute Controller */
	for (i = 0; i < STD_AR_NUM; i++) {
		data = STANDVGA_R8(REG_STATUS);
		STANDVGA_W8(REG_ZAR, i);
		STANDVGA_W8(REG_ZAR, vpit_regs.ar[i]);
	}

	/* Switching AR00[5](PAS) to 1 will NOT allow
	*   the CPU to change the palette registers.
	*   Meanwhile, the monitor will display normally.
	*/
	data = STANDVGA_R8(REG_STATUS);
	STANDVGA_W8(REG_ZAR, 0x20);
}

/*
 *     This function changes the destination of scaling up/down
 *     and CRTC timing registers iga_path : for which IGA
 *     scale_type : upscaling(VIA_EXPAND) or downscaling(VIA_SCALING_HW)
 */
void via_chrome9_set_scale_path(struct drm_crtc *crtc, u32 scale_type)
{
	struct via_chrome9_crtc *via_chrome9_crtc = to_via_chrome9_crtc(crtc);
	struct drm_device *dev = crtc->dev;
	struct drm_via_chrome9_private *p_priv =
		(struct drm_via_chrome9_private *)dev->dev_private;

	int iga_path = via_chrome9_crtc->crtc_id;
	u8 reg_cr_fd = via_chrome9_read_vga_io(REG_CRFD);

	if (p_priv->via_chrome9_chip_caps & (CAPS_IGA1_DOWNSCALING |
		CAPS_IGA1_EXPAND | CAPS_IGA2_DOWNSCALING)) {
		if (iga_path == IGA1)
			/* register reuse: select IGA1 path */
			reg_cr_fd |= BIT7;
		else
			/* register reuse: select IGA2 path */
			reg_cr_fd &= ~BIT7;
	}

	/* only IGA1 up scaling need to clear this bit CRFD.5. */
	if (p_priv->via_chrome9_chip_caps & CAPS_IGA1_EXPAND) {
		if ((IGA1 == iga_path) && ((VIA_HOR_EXPAND & scale_type) ||
			(VIA_VER_EXPAND & scale_type)))
			reg_cr_fd &= ~BIT5;
	}

	/* CRFD.0 = 0 : common IGA2, = 1 : downscaling IGA */
	if (p_priv->via_chrome9_chip_caps & (CAPS_IGA1_DOWNSCALING |
		CAPS_IGA2_DOWNSCALING)) {
		switch (scale_type) {
		case VIA_NONE_SCALING:
		case VIA_EXPAND:
		case VIA_HOR_EXPAND:
		case VIA_VER_EXPAND:
			/* register reuse: as common IGA2 */
			reg_cr_fd &= ~BIT0;
			break;

		case VIA_SCALING_HW:
			/* register reuse: as downscaling IGA */
			reg_cr_fd |= BIT0;
			break;

		default:
			break;
		}
	}

	via_chrome9_write_vga_io(REG_CRFD, reg_cr_fd);
}


/*
 * disable or enable IGA scale functions.
 *
 * input : iga_path    =    IGA1 or
 *                                IGA2 or
 *                                IGA1+IGA2
 *
 *           scale_type =   VIA_HOR_EXPAND or
 *                                VIA_VER_EXPAND or
 *                                VIA_EXPAND or
 *                                VIA_SCALING_HW or
 *                                VIA_SCALING_HW+VIA_EXPAND
 *
 */
bool via_chrome9_set_iga_scale_function(struct drm_crtc *crtc,
		u32 scale_type, bool is_enable_scale)
{
	struct via_chrome9_crtc *via_chrome9_crtc = to_via_chrome9_crtc(crtc);
	struct drm_device *dev = crtc->dev;
	struct drm_via_chrome9_private *p_priv =
		(struct drm_via_chrome9_private *)dev->dev_private;
	int iga_path = via_chrome9_crtc->crtc_id;

	if ((iga_path != IGA1) && (iga_path != IGA2))
		return false;

	if (!(scale_type & (VIA_SCALING_HW + VIA_EXPAND)))
		return false;

	if (is_enable_scale) {
		if (IGA2 == iga_path) {
			/* IGA2 scalings enable */
			if (p_priv->via_chrome9_chip_caps &
				CAPS_IGA2_DOWNSCALING) {
				if (VIA_SCALING_HW & scale_type) {
					via_chrome9_set_scale_path(
						crtc, VIA_SCALING_HW);
					/* Horizontal and Vertical scaling
					enable */
					via_chrome9_write_vga_io_bits(REG_CRA2,
						BIT7 | BIT3, BIT7 | BIT3);
					/* enable IGA down scaling */
					via_chrome9_write_vga_io_bits(REG_CR89,
						BIT0, BIT0);
					/* hor and ver scaling :
					Interpolation */
					via_chrome9_write_vga_io_bits(REG_CR79,
						BIT2 + BIT1, BIT2 + BIT1);
				}
			}

		if (VIA_EXPAND & scale_type) {
			via_chrome9_set_scale_path(crtc, VIA_EXPAND);
			/* enable IGA up scaling */
			via_chrome9_write_vga_io_bits(REG_CR79, BIT0, BIT0);
		}
		if ((VIA_EXPAND & scale_type) == VIA_EXPAND) {
			/* Horizontal and Vertical scaling enable */
			via_chrome9_write_vga_io_bits(REG_CRA2, BIT7 | BIT3,
				BIT7 | BIT3);
			/* hor and ver scaling : Interpolation */
			via_chrome9_write_vga_io_bits(REG_CR79, BIT2 + BIT1,
				BIT2 + BIT1);
		} else if (VIA_HOR_EXPAND & scale_type) {
			/* Horizontal scaling disable */
			via_chrome9_write_vga_io_bits(REG_CRA2, BIT7, BIT7);
			/* hor scaling : Interpolation */
			via_chrome9_write_vga_io_bits(REG_CR79, BIT1, BIT1);
		} else if (VIA_VER_EXPAND & scale_type) {
			/*Vertical scaling disable */
			via_chrome9_write_vga_io_bits(REG_CRA2, BIT3, BIT3);
			/* ver scaling : Interpolation */
			via_chrome9_write_vga_io_bits(REG_CR79, BIT2, BIT2);
		}
	}

	if (IGA1 == iga_path) {
		/* IGA1 scalings enable */
		if (p_priv->via_chrome9_chip_caps & CAPS_IGA1_DOWNSCALING) {
			if (VIA_SCALING_HW & scale_type) {
				via_chrome9_set_scale_path(crtc,
					VIA_SCALING_HW);
				/*Horizontal and Vertical scaling enable */
				via_chrome9_write_vga_io_bits(REG_CRA2,
					BIT7 | BIT3, BIT7 | BIT3);
				/* enable IGA down scaling */
				via_chrome9_write_vga_io_bits(REG_CR89,
					BIT0, BIT0);
				/* hor and ver scaling : Interpolation */
				via_chrome9_write_vga_io_bits(REG_CR79,
					 BIT2 + BIT1, BIT2 + BIT1);
			}
		}

		if (p_priv->via_chrome9_chip_caps & CAPS_IGA1_EXPAND) {
			if (VIA_EXPAND & scale_type) {
				via_chrome9_set_scale_path(crtc, VIA_EXPAND);
				/* enable IGA up scaling */
				via_chrome9_write_vga_io_bits(REG_CR79,
					BIT0, BIT0);
			}

			if ((VIA_EXPAND & scale_type) == VIA_EXPAND) {
				/* Horizontal and Vertical scaling enable */
				via_chrome9_write_vga_io_bits(REG_CRA2,
					BIT7 | BIT3, BIT7 | BIT3);
				/* hor and ver scaling : Interpolation */
				via_chrome9_write_vga_io_bits(REG_CR79,
					BIT2 + BIT1, BIT2 + BIT1);
			} else if (VIA_HOR_EXPAND & scale_type) {
				/* Horizontal scaling disable */
				via_chrome9_write_vga_io_bits(REG_CRA2,
					BIT7, BIT7);
				/* hor scaling : Interpolation */
				via_chrome9_write_vga_io_bits(REG_CR79,
					BIT1, BIT1);
			} else if (VIA_VER_EXPAND & scale_type) {
				/*Vertical scaling disable */
				via_chrome9_write_vga_io_bits(REG_CRA2,
					BIT3, BIT3);
				/* ver scaling : Interpolation */
				via_chrome9_write_vga_io_bits(REG_CR79,
					BIT2, BIT2);
			}
		}
	}
	return true;

	} else {
		if (IGA2 == iga_path) {
			/* IGA2 scalings disable */
			if (p_priv->via_chrome9_chip_caps &
				CAPS_IGA2_DOWNSCALING) {
				if (VIA_SCALING_HW & scale_type) {
					via_chrome9_set_scale_path(crtc,
						VIA_SCALING_HW);
					/* disable IGA down scaling and
					buffer sharing. */
					via_chrome9_write_vga_io_bits(REG_CR89,
						0x00, BIT7 + BIT0);
					/* Horizontal and Vertical
					scaling disable */
					via_chrome9_write_vga_io_bits(REG_CRA2,
						0x00, BIT7 | BIT3);
				}
			}
			via_chrome9_set_scale_path(crtc, VIA_EXPAND);

			if ((VIA_EXPAND & scale_type) == VIA_EXPAND) {
				/* disable IGA up scaling */
				via_chrome9_write_vga_io_bits(REG_CR79,
					0, BIT0);
				/* Horizontal and Vertical scaling
				disable */
				via_chrome9_write_vga_io_bits(REG_CRA2, 0x00,
					BIT7 | BIT3);
			} else if (VIA_HOR_EXPAND & scale_type) {
				/* Horizontal scaling disable */
				via_chrome9_write_vga_io_bits(REG_CRA2, 0x00,
					BIT7);
			} else if (VIA_VER_EXPAND & scale_type) {
				/* Vertical scaling disable */
				via_chrome9_write_vga_io_bits(REG_CRA2, 0x00,
					BIT3);
			}
		}

		if (IGA1 == iga_path) {
			/* IGA1 scalings disable */
			if (p_priv->via_chrome9_chip_caps &
				CAPS_IGA1_DOWNSCALING) {
				if (VIA_SCALING_HW & scale_type) {
					via_chrome9_set_scale_path(crtc,
						VIA_SCALING_HW);
					/* disable IGA down scaling and
					buffer sharing. */
					via_chrome9_write_vga_io_bits(REG_CR89,
						0x00, BIT7 + BIT0);
					/* Horizontal and Vertical scaling
					disable */
					via_chrome9_write_vga_io_bits(REG_CRA2,
						0x00, BIT7 | BIT3);
				}
			}

			if (p_priv->via_chrome9_chip_caps & CAPS_IGA1_EXPAND) {
				via_chrome9_set_scale_path(crtc, VIA_EXPAND);
				if ((VIA_EXPAND & scale_type) == VIA_EXPAND) {
					/* disable IGA up scaling */
					via_chrome9_write_vga_io_bits(REG_CR79,
						0, BIT0);
					/* Horizontal and Vertical scaling
					disable */
					via_chrome9_write_vga_io_bits(REG_CRA2,
						0x00, BIT7 | BIT3);
				} else if (VIA_HOR_EXPAND & scale_type) {
					/* Horizontal scaling disable */
					via_chrome9_write_vga_io_bits(REG_CRA2,
						0x00, BIT7);
				} else if (VIA_VER_EXPAND & scale_type) {
					/* Vertical scaling disable */
					via_chrome9_write_vga_io_bits(REG_CRA2,
						0x00, BIT3);
				}
			}
		}
		return true;
	}
}

/*
 * 1. get scale factors from source and dest H & V size
 * 2. load scale factors into registers
 * 3. enable H or V scale ( set CRA2 bit7 or bit3 )
 */
bool via_chrome9_load_iga_scale_factor_regs(
		u32 src_hor_regs, u32 src_ver_regs,
		u32 dst_hor_regs, u32 dst_ver_regs,
		u32 scale_type, u32 is_hor_or_ver)
{
	u32 hor_factor = 0, ver_factor = 0;
	u32 reg_ammount = 0;
	struct via_chrome9_io_bit *p_reg = NULL;

	if ((0 == src_hor_regs) || (0 == src_ver_regs) ||
		(0 == dst_hor_regs) || (0 == dst_ver_regs))
		return false;

	if (VIA_EXPAND == scale_type) {
		if (HOR_SCALE & is_hor_or_ver) {
			hor_factor = ((src_hor_regs - 1) * 4096) /
				(dst_hor_regs - 1);
			reg_ammount = via_lcd_scaling_regs.hor_regs.reg_num;
			p_reg = via_lcd_scaling_regs.hor_regs.reg;
			via_chrome9_load_regs(hor_factor, reg_ammount, p_reg);
			/* Horizontal scaling enable */
			via_chrome9_write_vga_io_bits(REG_CRA2, BIT7, BIT7);
		}

		if (VER_SCALE & is_hor_or_ver) {
			ver_factor = ((src_ver_regs - 1) * 2048) /
				(dst_ver_regs - 1);
			reg_ammount = via_lcd_scaling_regs.ver_regs.reg_num;
			p_reg = via_lcd_scaling_regs.ver_regs.reg;
			via_chrome9_load_regs(ver_factor, reg_ammount, p_reg);
			/* Vertical scaling enable */
			via_chrome9_write_vga_io_bits(REG_CRA2, BIT3, BIT3);
		}

	} else if (VIA_SCALING_HW == scale_type) {

		if (src_hor_regs > dst_hor_regs)
			hor_factor =
				((src_hor_regs - dst_hor_regs) * 4096) /
				dst_hor_regs;

		if (src_ver_regs > dst_ver_regs)
			ver_factor =
				((src_ver_regs - dst_ver_regs) * 2048) /
				dst_ver_regs;

		reg_ammount = via_lcd_scaling_regs.hor_regs.reg_num;
		p_reg = via_lcd_scaling_regs.hor_regs.reg;
		via_chrome9_load_regs(hor_factor, reg_ammount, p_reg);

		reg_ammount = via_lcd_scaling_regs.ver_regs.reg_num;
		p_reg = via_lcd_scaling_regs.ver_regs.reg;
		via_chrome9_load_regs(ver_factor, reg_ammount, p_reg);

		/* set buffer sharing enable bit . */
		if (hor_factor || ver_factor) {
			if (dst_hor_regs > 1024)
				via_chrome9_write_vga_io_bits(REG_CR89,
					BIT7, BIT7);
			else
				via_chrome9_write_vga_io_bits(REG_CR89,
					0x00, BIT7);
		}

		if (hor_factor)
			/* CRA2[7]:1 Enable Hor scaling
			CRA2[6]:1 Linear Mode */
			via_chrome9_write_vga_io_bits(REG_CRA2, BIT7 + BIT6,
				BIT7 + BIT6);
		else
			via_chrome9_write_vga_io_bits(REG_CRA2, 0, BIT7);

		if (ver_factor)
			via_chrome9_write_vga_io_bits(REG_CRA2, BIT3, BIT3);
		else
			via_chrome9_write_vga_io_bits(REG_CRA2, 0, BIT3);
	}

	return true;
}

void via_chrome9_set_iga2_downscale_source_timing(
		struct drm_crtc *crtc,
		unsigned int srcx, unsigned int srcy,
		unsigned int viewx, unsigned int viewy,
		struct display_timing *p_timing_tbl)
{
	struct display_timing src_timing_tbl, *p_src_timing_tbl;
	p_src_timing_tbl = &src_timing_tbl;

	/* derived source timing */
	if (srcx <= viewx) {
		p_src_timing_tbl->hor_total = p_timing_tbl->hor_total;
		p_src_timing_tbl->hor_addr = p_timing_tbl->hor_addr;
	} else {
		p_src_timing_tbl->hor_total =
			srcx + (p_timing_tbl->hor_total -
			p_timing_tbl->hor_addr);
		p_src_timing_tbl->hor_addr = srcx;
	}
	p_src_timing_tbl->hor_blank_start = p_src_timing_tbl->hor_addr;
	p_src_timing_tbl->hor_blank_end = p_src_timing_tbl->hor_total;
	p_src_timing_tbl->hor_sync_start = p_src_timing_tbl->hor_addr + 2;
	p_src_timing_tbl->hor_sync_end = p_src_timing_tbl->hor_sync_start + 1;

	if (srcy <= viewy) {
		p_src_timing_tbl->ver_total = p_timing_tbl->ver_total;
		p_src_timing_tbl->ver_addr = p_timing_tbl->ver_addr;
	} else {
		p_src_timing_tbl->ver_total =
			srcy + (p_timing_tbl->ver_total -
			p_timing_tbl->ver_addr);
		p_src_timing_tbl->ver_addr = srcy;
	}
	p_src_timing_tbl->ver_blank_start = p_src_timing_tbl->ver_addr;
	p_src_timing_tbl->ver_blank_end = p_src_timing_tbl->ver_total;
	p_src_timing_tbl->ver_sync_start = p_src_timing_tbl->ver_addr + 2;
	p_src_timing_tbl->ver_sync_end = p_src_timing_tbl->ver_sync_start + 1;

	via_chrome9_set_scale_path(crtc, VIA_NONE_SCALING);
	/* load src timing */
	via_chrome9_load_crtc_timing(crtc, src_timing_tbl);
}

/* Patch for iga1 clock */
static void via_chrome9_plus_vck_to_iga1_timing(u16 htotal)
{
	switch (htotal % 8) {
	case 0:
	default:
		via_chrome9_write_vga_io_bits(REG_CR47, 0x00,
			BIT7 + BIT6 + BIT3);
		break;
	case 2:
		via_chrome9_write_vga_io_bits(REG_CR47, BIT7,
			BIT7 + BIT6 + BIT3);
		break;
	case 4:
		via_chrome9_write_vga_io_bits(REG_CR47, BIT6,
			BIT7 + BIT6 + BIT3);
		break;
	case 6:
		via_chrome9_write_vga_io_bits(REG_CR47, BIT3,
			BIT7 + BIT6 + BIT3);
		break;
	}
}

/* Load offset registers */
static void via_chrome9_load_offset_regs(struct drm_crtc *crtc, u32 offset)
{
	struct via_chrome9_crtc *via_chrome9_crtc = to_via_chrome9_crtc(crtc);
	struct drm_device *dev = crtc->dev;

	int iga_path = via_chrome9_crtc->crtc_id;
	u32 reg_value = offset;
	u8 reg_amount = 0;
	struct via_chrome9_io_bit *reg = NULL;

	/* Check input variable iga_path */
	if ((iga_path != IGA1) && (iga_path != IGA2))
		return;

	if (IGA1 == iga_path) {
		reg_amount = via_chrome9_offset_regs.iga1.reg_num;
		reg = via_chrome9_offset_regs.iga1.reg;
	} else {
		switch (dev->pci_device) {
		case VX800_DEVICE:
		case VX855_DEVICE:
		case VX900_DEVICE:
			reg_amount = via_chrome9_iga2_offset_13bit_regs.reg_num;
			reg = via_chrome9_iga2_offset_13bit_regs.reg;
			break;
		default:
			reg_amount = via_chrome9_offset_regs.iga2.reg_num;
			reg = via_chrome9_offset_regs.iga2.reg;
			break;
		}
	}
	via_chrome9_load_regs(reg_value, reg_amount, reg);
}

/* Load fetch count registers */
static void via_chrome9_load_fetch_count_regs(
		struct drm_crtc *crtc, u32 fetch_count)
{
	struct via_chrome9_crtc *via_chrome9_crtc = to_via_chrome9_crtc(crtc);

	int iga_path = via_chrome9_crtc->crtc_id;
	u32 reg_value = fetch_count;
	u32 reg_amount = 0;
	struct via_chrome9_io_bit *reg = NULL;

	/* Check input variable iga_path */
	if ((iga_path != IGA1) && (iga_path != IGA2))
		return;

	if (IGA1 == iga_path) {
		reg_amount = via_chrome9_fetch_count_regs.iga1.reg_num;
		reg = via_chrome9_fetch_count_regs.iga1.reg;
	} else {
		reg_amount = via_chrome9_fetch_count_regs.iga2.reg_num;
		reg = via_chrome9_fetch_count_regs.iga2.reg;
	}
	via_chrome9_load_regs(reg_value, reg_amount, reg);
}

/* Load fifo registers (depending on chip name),
The function should be called when setting mode */
void via_chrome9_load_fifo_regs(
		struct drm_crtc *crtc, u32 mode_h, u32 mode_v)
{
	struct via_chrome9_crtc *via_chrome9_crtc = to_via_chrome9_crtc(crtc);
	struct drm_device *dev = crtc->dev;
	struct via_chrome9_io_bit *reg = NULL;

	int iga_path = via_chrome9_crtc->crtc_id;
	u32 reg_value;
	u32 reg_amount;
	struct via_fifo_value iga1_fifo;
	struct via_fifo_value iga2_fifo;
	u32 i = 0;

	via_chrome9_mem_set(&iga1_fifo, sizeof(struct via_fifo_value));
	via_chrome9_mem_set(&iga2_fifo, sizeof(struct via_fifo_value));

	for (i = 0; i < NUM_TOTAL_DISP_FIFO_TABLE; i++) {
		if (via_chrome9_disp_fifo_table[i].device_id ==
			dev->pci_device) {
			iga1_fifo = via_chrome9_disp_fifo_table[i].iga1_fifo;
			iga2_fifo = via_chrome9_disp_fifo_table[i].iga2_fifo;
			break;
		}
	}

	if (IGA1 == iga_path) {
		/* Set IGA1 Display FIFO Depath */
		reg_value =
			VIA_IGA1_FIFO_DEPTH_SELECT_FORMULA(iga1_fifo.max_depth);
		reg_amount = via_chrome9_display_fifo_depth_reg.
			iga1_fifo_depth_select_reg.reg_num;
		reg = via_chrome9_display_fifo_depth_reg.
			iga1_fifo_depth_select_reg.reg;
		via_chrome9_load_regs(reg_value, reg_amount, reg);

		/* Set IGA1 Display FIFO Threshold Select */
		reg_value = VIA_IGA1_FIFO_THRESHOLD_FORMULA(
			iga1_fifo.threshold);
		reg_amount = via_chrome9_fifo_threshold_select_reg.
			iga1_fifo_threshold_select_reg.reg_num;
		reg = via_chrome9_fifo_threshold_select_reg.
			iga1_fifo_threshold_select_reg.reg;
		via_chrome9_load_regs(reg_value, reg_amount, reg);

		/* Set IGA1 GFX PREG Threshold Select */
		reg_value = VIA_IGA1_FIFO_HIGH_THRESHOLD_FORMULA(
			iga1_fifo.high_threshold);
		reg_amount = via_chrome9_fifo_high_threshold_select_reg.
			iga1_fifo_high_thresold_select_reg.reg_num;
		reg = via_chrome9_fifo_high_threshold_select_reg.
			iga1_fifo_high_thresold_select_reg.reg;
		via_chrome9_load_regs(reg_value, reg_amount, reg);

		/* Set IGA1 Display Gueue Expire Num */
		reg_value = VIA_IGA1_DISPLAY_QUEUE_EXPIRE_NUM_FORMULA(
			iga1_fifo.disp_queue_expired_num);
		reg_amount = via_chrome9_display_queue_expire_num_reg.
			iga1_display_queue_expire_num_reg.reg_num;
		reg = via_chrome9_display_queue_expire_num_reg.
			iga1_display_queue_expire_num_reg.reg;
		via_chrome9_load_regs(reg_value, reg_amount, reg);
	} else {
		/* Set IGA2 Display FIFO Depath Select */
		reg_value =
		VIA_IGA2_FIFO_DEPTH_SELECT_FORMULA(iga2_fifo.max_depth);
		reg_amount = via_chrome9_display_fifo_depth_reg.
			iga2_fifo_depth_select_reg.reg_num;
		reg = via_chrome9_display_fifo_depth_reg.
			iga2_fifo_depth_select_reg.reg;
		via_chrome9_load_regs(reg_value, reg_amount, reg);

		/* Set IGA2 Display FIFO Threshold Select */
		reg_value = VIA_IGA2_FIFO_THRESHOLD_FORMULA(
			iga2_fifo.threshold);
		reg_amount = via_chrome9_fifo_threshold_select_reg.
			iga2_fifo_threshold_select_reg.reg_num;
		reg = via_chrome9_fifo_threshold_select_reg.
			iga2_fifo_threshold_select_reg.reg;
		via_chrome9_load_regs(reg_value, reg_amount, reg);

		/* Set IGA2 GFX PREG Threshold Select */
		reg_value = VIA_IGA2_FIFO_HIGH_THRESHOLD_FORMULA(
			iga2_fifo.high_threshold);
		reg_amount = via_chrome9_fifo_high_threshold_select_reg.
			iga2_fifo_high_thresold_select_reg.reg_num;
		reg = via_chrome9_fifo_high_threshold_select_reg.
			iga2_fifo_high_thresold_select_reg.reg;
		via_chrome9_load_regs(reg_value, reg_amount, reg);

		/* Set IGA2 Display Queue Expire Num */
		reg_value = VIA_IGA2_DISPLAY_QUEUE_EXPIRE_NUM_FORMULA(
			iga2_fifo.disp_queue_expired_num);
		reg_amount = via_chrome9_display_queue_expire_num_reg.
			iga2_display_queue_expire_num_reg.reg_num;
		reg = via_chrome9_display_queue_expire_num_reg.
			iga2_display_queue_expire_num_reg.reg;
		via_chrome9_load_regs(reg_value, reg_amount, reg);
	}
}

/* Load color depth registers */
static void via_chrome9_load_color_depth_regs(struct drm_crtc *crtc, int bpp)
{
	struct via_chrome9_crtc *via_chrome9_crtc = to_via_chrome9_crtc(crtc);
	int iga_path = via_chrome9_crtc->crtc_id;
	/* Check input variable a_iga_path */
	if ((iga_path != IGA1) && (iga_path != IGA2))
		return;

	if (IGA1 == iga_path) {
		switch (bpp) {
		case BPP8:
			via_chrome9_write_vga_io_bits(REG_SR15, 0xA2, 0xFE);
			break;

		case BPP16:
			via_chrome9_write_vga_io_bits(REG_SR15, 0xB6, 0xFE);
			break;

		case BPP32:
			via_chrome9_write_vga_io_bits(REG_SR15, 0xAE, 0xFE);
			break;

		default:
			break;
		}
	} else {
		switch (bpp) {
		case BPP8:
			via_chrome9_write_vga_io_bits(REG_CR67, 0x00, 0xC0);
			break;

		case BPP16:
			via_chrome9_write_vga_io_bits(REG_CR67, 0x40, 0xC0);
			break;

		case BPP32:
			via_chrome9_write_vga_io_bits(REG_CR67, 0xC0, 0xC0);
			break;

		default:
			break;
		}
	}
}

void via_chrome9_get_clock_value(u32 pll_type, u32 frequency,
		u32 *p_pll_value)
{
	int i;
	KMS_DEBUG(" pll_type = %x , frequency = %x\n", pll_type, frequency);


	for (i = 0; i < NUM_TOTAL_PLL_TABLE; i++) {
		if (frequency == via_chrome9_pll_value[i].clk) {
			switch (pll_type) {
			case PLL_TYPE_PLL_3_NEW:
				*p_pll_value =
					via_chrome9_pll_value[i].pll_3_new;
				break;

			case PLL_TYPE_PLL_3_ADV:
				*p_pll_value =
					via_chrome9_pll_value[i].pll_3_adv;
				break;
			default:
				break;
			}
		}
	}

	KMS_DEBUG("pll_value = %x\n", *p_pll_value);
}

/*
* via_chrome9_get_mrn
* This function gets the best frequency M, R, N value according to
* the input clock frequence
* IN :
* frequency : Clock frequence (.Hz)
* OUT :
* pll_mrn : PLL registers M, R, N value
* [31:16]  DM[7:0]
* [15:8 ]  DR[2:0]
* [7 :0 ]  DN[6:0]
**/

u32 via_chrome9_get_mrn(u32 pll_type, u32 frequency)
{
	u32 pll_mplus2, pll_r, pll_nplus2;
	u32 best_clk_diff = frequency;
	u32 best_pll_mplus2 = 2;
	u32 best_pll_nplus2 = 2;
	u32 best_pll_r = 0;
	u32 clk_diff;
	u32 pll_fout;
	u32 pll_fvco;
	u32 pll_mrn = 0;

	struct pll_mrn_value pll_temp_array[5] = {
		{ 0, 0, 0, 0, 0 },
		{ 0, 0, 0, 0, 0 },
		{ 0, 0, 0, 0, 0 },
		{ 0, 0, 0, 0, 0 },
		{ 0, 0, 0, 0, 0 } };
	int counter_pll_temp_array = 0;

	/* Fout = Fin * (M+2) / [(N+2) * 2^R]
	Fin = 14318180Hz  */
	/* N[6:0] */
	for (pll_nplus2 = 2; pll_nplus2 < 6; pll_nplus2++) {
		/* R[2:0] */
		for (pll_r = 0; pll_r < 6; pll_r++) {
			/* M[9:0] */
			for (pll_mplus2 = 2; pll_mplus2 < 512; pll_mplus2++) {
				/* first divide pll_nplus2 then multiply
				pll_mplus2 We have to reduce pll_mplus2
				to 512 to get rid of the overflow */
				pll_fvco =
					(VIA_CHROME9_CLK_REFERENCE /
					pll_nplus2) * pll_mplus2;
				if ((pll_fvco >= CSR_VCO_DOWN) &&
					(pll_fvco <= CSR_VCO_UP)) {
					pll_fout = pll_fvco >> pll_r;
					if (pll_fout < frequency)
						clk_diff = frequency - pll_fout;
					else
						clk_diff = pll_fout - frequency;

					/* if frequency(which is the PLL we want
					to set) > 150MHz, the MRN value we
					write in register must < frequency, and
					get MRN value whose M is the largeset */
					/**
					 * origin code :
					 * if (pll_fout <= frequency &&
					 * frequency >= 150000000) {
					 * because there may be an issue here:
					 * 1920x1200@60Hz 193.25MHz
					 * we get 86 04 05 as PLL,
					 * this PLL caused 191.86MHz,
					 * the deviation may be too large
					 * so that there will be some lines
					 * at right of desktop.
					 * This change is much risk,
					 * if there is not suitable,
					 * can be revert back.
					 */
					if (frequency >= 150000000) {
						if ((clk_diff <=
							pll_temp_array[0].diff_clk) ||
							pll_temp_array[0].pll_fout == 0) {
							for (counter_pll_temp_array =
								((sizeof(pll_temp_array) /
								sizeof(struct pll_mrn_value)) - 1);
								counter_pll_temp_array >= 1;
								counter_pll_temp_array--)

								pll_temp_array[counter_pll_temp_array] =
									pll_temp_array[counter_pll_temp_array - 1];

							pll_temp_array[0].pll_m = pll_mplus2;
							pll_temp_array[0].pll_r = pll_r;
							pll_temp_array[0].pll_n = pll_nplus2;
							pll_temp_array[0].diff_clk = clk_diff;
							pll_temp_array[0].pll_fout = pll_fout;
						}
					}

					if (clk_diff < best_clk_diff) {
						best_clk_diff = clk_diff;
						best_pll_mplus2 = pll_mplus2;
						best_pll_nplus2 = pll_nplus2;
						best_pll_r = pll_r;
					}
				} /* if pll_fvco in VCO range */
			} /* for PLL M */
		} /* for PLL R */
	} /* for PLL N */

	/* if frequency(which is the PLL we want to set) > 150MHz,
	the MRN value we write in register must < frequency,
	and get MRN value whose M is the largeset */
	if (frequency > 150000000) {
		counter_pll_temp_array = 0;
		best_pll_mplus2 = pll_temp_array[counter_pll_temp_array].pll_m;
		best_pll_r = pll_temp_array[counter_pll_temp_array].pll_r;
		best_pll_nplus2 = pll_temp_array[counter_pll_temp_array].pll_n;
	}

	if (PLL_TYPE_PLL_3_ADV == pll_type) {
		/* Clcok Synthesizer Value 0 : DM[7:0] */
		pll_mrn = ((best_pll_mplus2) & 0xFF) << 16;
		/* Clcok Synthesizer Value 1[1:0] : DM[9:8]
		Clcok Synthesizer Value 1[4:2] : DR[2:0]
		Clcok Synthesizer Value 1[7] : DTZ[0] */
		pll_mrn |= (((PLL_DTZ_DEFAULT & 0x1) << 7) |
			((best_pll_r & 0x7) << 2) |
			(((best_pll_mplus2) >> 8) & 0x3)) << 8;
		/* Clcok Synthesizer Value 2[6:0] : DN[6:0]
		Clcok Synthesizer Value 2[7] : DTZ[1] */
		pll_mrn |= (((PLL_DTZ_DEFAULT >> 1) & 0x1) << 7) |
			((best_pll_nplus2) &
			0x7F);
	} else {
		/* Clcok Synthesizer Value 0 : DM[7:0] */
		pll_mrn = ((best_pll_mplus2 - 2) & 0xFF) << 16;
		/* Clcok Synthesizer Value 1[1:0] : DM[9:8]
		Clcok Synthesizer Value 1[4:2] : DR[2:0]
		Clcok Synthesizer Value 1[7] : DTZ[0] */
		pll_mrn |= (((PLL_DTZ_DEFAULT & 0x1) << 7) |
			((best_pll_r & 0x7) << 2) |
			(((best_pll_mplus2 - 2) >> 8) & 0x3)) << 8;
		/* Clcok Synthesizer Value 2[6:0] : DN[6:0]
		Clcok Synthesizer Value 2[7] : DTZ[1] */
		pll_mrn |= (((PLL_DTZ_DEFAULT >> 1) & 0x1) << 7) |
			((best_pll_nplus2 - 2)
			& 0x7F);
	}

	return pll_mrn;
}

/* Set Iga clock */
void via_chrome9_set_vclk(struct drm_crtc *crtc, u32 pll_value)
{
	struct via_chrome9_crtc *via_chrome9_crtc = to_via_chrome9_crtc(crtc);
	struct drm_device *dev = crtc->dev;
	int iga_path = via_chrome9_crtc->crtc_id;

	/* Check input variable a_iga_path */
	if ((iga_path != IGA1) && (iga_path != IGA2))
		return;

	if (IGA1 == iga_path) {
		/* Enter HW reset state, CR17[7] = 0 */
		via_chrome9_iga1_hw_reset_enable(dev);
		/* set vck */
		via_chrome9_write_vga_io(REG_SR44,
			(u8)((pll_value & 0x00FF0000)
			>> 16));
		via_chrome9_write_vga_io(REG_SR45,
			(u8)((pll_value & 0x0000FF00)
			>> 8));
		via_chrome9_write_vga_io(REG_SR46,
			(u8)((pll_value & 0x000000FF)));
		/* Fire */
		via_chrome9_write_misc_io(via_chrome9_read_misc_io() |
			(BIT2 + BIT3));
		/* SR40[1] = 1 */
		via_chrome9_write_vga_io_bits(REG_SR40, 0x02, 0x02);
		/* SR40[1] = 0 */
		via_chrome9_write_vga_io_bits(REG_SR40, 0x00, 0x02);
		/* exit hw reset */
		via_chrome9_iga1_hw_reset_disable(dev);
	} else {
		/* Enter HW reset state */
		via_chrome9_iga2_hw_reset_enable(dev);
		/* set lck */
		via_chrome9_write_vga_io(REG_SR4A,
			(u8)((pll_value & 0x00FF0000)
			>> 16));
		via_chrome9_write_vga_io(REG_SR4B,
			(u8)((pll_value & 0x0000FF00)
			>> 8));
		via_chrome9_write_vga_io(REG_SR4C,
			(u8)((pll_value & 0x000000FF)));
		/* reset pll */
		via_chrome9_write_vga_io_bits(REG_SR40, 0x04, 0x04);
		via_chrome9_write_vga_io_bits(REG_SR40, 0x00, 0x04);
		/* exit hw reset */
		via_chrome9_iga2_hw_reset_disable(dev);
	}
}


/* Set timing for iga, it's a very important function! */
bool via_chrome9_set_iga_timing(struct drm_crtc *crtc,
		struct drm_display_mode *mode,
		struct drm_display_mode *adjusted_mode)
{
	struct via_chrome9_crtc *via_chrome9_crtc = to_via_chrome9_crtc(crtc);
	struct drm_device *dev = crtc->dev;
	struct drm_via_chrome9_private *p_priv =
		(struct drm_via_chrome9_private *)dev->dev_private;

	int iga_path = via_chrome9_crtc->crtc_id;
	int iga_scale_status = via_chrome9_crtc->crtc_scale_status;
	u32 pll_value = 0;
	struct display_timing_table via_timing;

	/* 1. Sanity check */
	if (iga_path != IGA1 && iga_path != IGA2)
		return false;

	/* Patch for interlace mode:
	XServer will force VTotal to be odd  for unknown reason. Reset VTotal */
	if (mode->flags & DRM_MODE_FLAG_INTERLACE) {
		/**
		* we need to consider when HDMI over scan adjusted here.
		* so CrtcVBlankEnd is not equal to CrtcVTotal.
		*/
		u32 top_border_value =
			adjusted_mode->crtc_vtotal -
			adjusted_mode->crtc_vblank_end;
		mode->crtc_vtotal = (mode->vtotal) / 2;
		mode->crtc_vblank_end = mode->crtc_vtotal;
		adjusted_mode->crtc_vtotal = (adjusted_mode->vtotal) / 2;
		adjusted_mode->crtc_vblank_end =
			adjusted_mode->crtc_vtotal - top_border_value;
	}

	/* 2. Get Timing from adjusted_mode */
	via_chrome9_get_timing_info_from_mode(adjusted_mode, &via_timing);

	/* 3.vpit register is just for IGA1, but for more stable,
	we set it both for IGA1 and IGA2. */
	via_chrome9_load_vpit_regs();

	/* 4. Unlock */
	via_chrome9_unlock_crtc(dev);

	/* 5. IGA1 reset */
	if (IGA1 == iga_path) {
		/* initial CR09=0 */
		via_chrome9_write_vga_io(REG_CR09, 0x00);
		via_chrome9_write_vga_io_bits(REG_CR11, 0x00, BIT6);
	}

	/* 6. disabe IGA scales first */
	via_chrome9_set_iga_scale_function(crtc,
		VIA_SCALING_HW + VIA_EXPAND, false);

	/* 7. Load crtc timing and IGA scaling */
	if (VIA_SCALING_HW & iga_scale_status) {
		/* I. down scaling */
		if (IGA2 == iga_path) {
			if (p_priv->via_chrome9_chip_caps &
				CAPS_IGA2_DOWNSCALING) {

				/*1.enable IGA2 down scaling and set Interpolation */
				via_chrome9_set_iga_scale_function(crtc,
					VIA_SCALING_HW, true);

				/*2.load hor and ver downscaling factor */
				/**
				* interlace modes scaling support(example 1080I):
				* we should use mode->crtc_vdisplay here,
				* because crtc_vdisplay=540, vdisplay=1080,
				* we need 540 here, not 1080.
				*/
				via_chrome9_load_iga_scale_factor_regs(
					mode->crtc_hdisplay,
					mode->crtc_vdisplay,
					 adjusted_mode->crtc_hdisplay,
					adjusted_mode->crtc_vdisplay,
					VIA_SCALING_HW,
					HOR_VER_SCALE);
				/*3.load src timing to timing registers */
				/**
				 * interlace modes scaling support(example 1080I):
				 * we should use mode->crtc_vdisplay here,
				 * because crtc_vdisplay=540, vdisplay=1080,
				 * we need 540 here, not 1080.
				 */
				via_chrome9_set_iga2_downscale_source_timing(
					crtc,
					mode->crtc_hdisplay,
					mode->crtc_vdisplay,
					adjusted_mode->crtc_hdisplay,
					adjusted_mode->crtc_vdisplay,
					&(via_timing.timing));

				/*4.Download dst timing */
				via_chrome9_set_scale_path(crtc,
					VIA_SCALING_HW);
				via_chrome9_load_crtc_timing(crtc,
					via_timing.timing);
				/* very necessary to set IGA to
				none scaling status , */
				/* need to fix why so need. */
				via_chrome9_set_scale_path(crtc,
					VIA_NONE_SCALING);
			}

		} else {
			if (p_priv->via_chrome9_chip_caps &
				CAPS_IGA1_DOWNSCALING)
				;
		}
	} else {
		/* when not down scaling,
		we only need load one timing. */
		via_chrome9_load_crtc_timing(crtc, via_timing.timing);

		if (IGA1 == iga_path)
			via_chrome9_plus_vck_to_iga1_timing(
				via_timing.timing.hor_total);

		/* II. up scaling */
		if (VIA_EXPAND & iga_scale_status) {
			if (IGA2 == iga_path) {
				/* Horizontal scaling */
				if (iga_scale_status & VIA_HOR_EXPAND) {
					via_chrome9_set_iga_scale_function(
						crtc,
						VIA_HOR_EXPAND,
						true);
					via_chrome9_load_iga_scale_factor_regs(
						mode->hdisplay,
						mode->vdisplay,
						adjusted_mode->hdisplay,
						adjusted_mode->vdisplay,
						VIA_EXPAND, HOR_SCALE);
				}
				/* Vertical scaling */
				if (iga_scale_status & VIA_VER_EXPAND) {
					via_chrome9_set_iga_scale_function(
						crtc,
						VIA_VER_EXPAND,
						true);
					via_chrome9_load_iga_scale_factor_regs(
						mode->hdisplay,
						mode->vdisplay,
						adjusted_mode->hdisplay,
						adjusted_mode->vdisplay,
						VIA_EXPAND, VER_SCALE);
				}
			} else {
				if (p_priv->via_chrome9_chip_caps &
					CAPS_IGA1_EXPAND)
					;
			}
		} else {
			/* III. no scaling */
		}

	}

	/* Lock */
	via_chrome9_lock_crtc();

	/* interlace setting */
	if (adjusted_mode->flags & DRM_MODE_FLAG_INTERLACE) {
		if (IGA1 == via_chrome9_crtc->crtc_id)
			via_chrome9_write_vga_io_bits(REG_CR33, BIT6, BIT6);
		else if (IGA2 == via_chrome9_crtc->crtc_id)
			via_chrome9_write_vga_io_bits(REG_CR67, BIT5, BIT5);
	} else {
		/* non-interlace, clear interlace setting. */
		if (IGA1 == via_chrome9_crtc->crtc_id)
			via_chrome9_write_vga_io_bits(REG_CR33, 0, BIT6);
		else if (IGA2 == via_chrome9_crtc->crtc_id)
			via_chrome9_write_vga_io_bits(REG_CR67, 0, BIT5);
	}

	/**
	* Set clock pll from clk.
	*  if Tv : we don't need to set pll. so the clk is 0.
	*/
	if (via_timing.clk) {
		if (VIA_SCALING_HW == iga_scale_status)
			pll_value = via_chrome9_get_mrn(
				p_priv->via_chrome9_pll_type,
				via_timing.clk * 2);
		else
			pll_value = via_chrome9_get_mrn(
				p_priv->via_chrome9_pll_type,
				via_timing.clk);
		via_chrome9_set_vclk(crtc, pll_value);
	}

	return true;
}


static void via_chrome9_enable_secdisp_channel(void)
{
	/* to enable second display channel. */
	via_chrome9_write_vga_io_bits(REG_CR6A, BIT7, BIT7);
}

static void via_chrome9_disable_secdisp_channel(void)
{
	/* to disable second display channel. */
	via_chrome9_write_vga_io_bits(REG_CR6A, 0x00, BIT7);
}

static void via_chrome9_set_lut(struct drm_crtc *crtc)
{
	struct via_chrome9_crtc *via_chrome9_crtc = to_via_chrome9_crtc(crtc);
	u8 sr1a, sr1b, cr67;
	int i;

	sr1a = via_chrome9_read_vga_io(REG_SR1A);
	sr1b = via_chrome9_read_vga_io(REG_SR1B);
	cr67 = via_chrome9_read_vga_io(REG_CR67);

	if (IGA2 == via_chrome9_crtc->crtc_id) {
		/* Prepare for IGA2's LUT initialization: */
		/* 1. Change Shadow to Secondary Display's LUT. */
		via_chrome9_write_vga_io(REG_SR1A, sr1a | 0x01);
		/* 2. Enable Secondary Display Engine. */
		via_chrome9_write_vga_io(REG_SR1B, sr1b | 0x80);
		/* 3. Second Display Color Depth should be 8bpp. */
		via_chrome9_write_vga_io(REG_CR67, cr67 & 0x3F);

		if (!(via_chrome9_read_vga_io(REG_CR6A) & BIT7))
			/* to enable second display channel. */
			via_chrome9_write_vga_io_bits(REG_CR6A, BIT7, BIT7);

		/* Fill in IGA2's LUT. */
		for (i = 0; i < 256; i++) {
			STANDVGA_W8(REG_PEL, i);
			STANDVGA_W8(REG_PEL + 1, via_chrome9_crtc->lut_r[i]);
			STANDVGA_W8(REG_PEL + 1, via_chrome9_crtc->lut_g[i]);
			STANDVGA_W8(REG_PEL + 1, via_chrome9_crtc->lut_b[i]);
		}
		/* Disable gamma in case it was enabled previously */
		via_chrome9_write_vga_io_bits(REG_CR6A, 0x0, BIT1);
	}

	if (IGA1 == via_chrome9_crtc->crtc_id) {
		/* Prepare for initialize IGA1's LUT: */
		/* Change to Primary Display's LUT. */
		via_chrome9_write_vga_io(REG_SR1A, sr1a & 0xFE);
		via_chrome9_write_vga_io(REG_SR1B, sr1b);
		via_chrome9_write_vga_io(REG_CR67, cr67);

		/* Fill in IGA1's LUT. */
		for (i = 0; i < 256; i++) {
			STANDVGA_W8(REG_PEL, i);
			STANDVGA_W8(REG_PEL + 1, via_chrome9_crtc->lut_r[i]);
			STANDVGA_W8(REG_PEL + 1, via_chrome9_crtc->lut_g[i]);
			STANDVGA_W8(REG_PEL + 1, via_chrome9_crtc->lut_b[i]);
		}
		/* enable LUT */
		via_chrome9_write_vga_io_bits(REG_SR1B, 0x0, BIT0);
		/* Disable gamma in case it was enabled previously */
		via_chrome9_write_vga_io_bits(REG_CR33, 0x0, BIT7);
	}

	/* access Primary Display's LUT. */
	via_chrome9_write_vga_io(REG_SR1A, sr1a & 0xFE);
}

static void via_chrome9_set_gamma(struct drm_crtc *crtc)
{
	struct via_chrome9_crtc *via_chrome9_crtc = to_via_chrome9_crtc(crtc);

	int i, sr1a;

	sr1a = via_chrome9_read_vga_io(REG_SR1A);

	if (IGA1 == via_chrome9_crtc->crtc_id) {
		/* Enable Gamma */
		via_chrome9_write_vga_io_bits(REG_CR33, 0x80, BIT7);
		via_chrome9_write_vga_io_bits(REG_SR1A, 0x0, BIT0);

		/* Fill in IGA1's gamma. */
		for (i = 0; i < 256; i++) {
			STANDVGA_W8(REG_PEL, i);
			STANDVGA_W8(REG_PEL + 1, via_chrome9_crtc->lut_r[i]);
			STANDVGA_W8(REG_PEL + 1, via_chrome9_crtc->lut_g[i]);
			STANDVGA_W8(REG_PEL + 1, via_chrome9_crtc->lut_b[i]);
		}
	}

	if (IGA2 == via_chrome9_crtc->crtc_id) {
		via_chrome9_write_vga_io_bits(REG_SR1A, 0x01, BIT0);
		/* Enable Gamma */
		via_chrome9_write_vga_io_bits(REG_CR6A, 0x02, BIT1);

		/* Before we fill the second LUT, we have to enable
		*  second display channel. If it's enabled before,
		*  we don't need to do that, or else the secondary
		*  display will be dark for about 1 sec and then be
		*  turned on again.
		*/
		if (!(via_chrome9_read_vga_io(REG_CR6A) & BIT7))
			/* to enable second display channel. */
			via_chrome9_write_vga_io_bits(REG_CR6A, BIT7, BIT7);

		/* Fill in IGA2's gamma. */
		for (i = 0; i < 256; i++) {
			STANDVGA_W8(REG_PEL, i);
			STANDVGA_W8(REG_PEL + 1, via_chrome9_crtc->lut_r[i]);
			STANDVGA_W8(REG_PEL + 1, via_chrome9_crtc->lut_g[i]);
			STANDVGA_W8(REG_PEL + 1, via_chrome9_crtc->lut_b[i]);
		}
	}
	via_chrome9_write_vga_io(REG_SR1A, sr1a);
}

void via_chrome9_set_gamma_or_lut(struct drm_crtc *crtc)
{
	struct via_chrome9_crtc *via_chrome9_crtc = to_via_chrome9_crtc(crtc);
	struct drm_device *dev = crtc->dev;
	struct drm_framebuffer *fb = NULL;
	int iga_path = via_chrome9_crtc->crtc_id;
	int bits_per_pixel = 0;

	if (!drm_helper_crtc_in_use(crtc))
		return;

	fb = crtc->fb;
	if (fb == NULL) {
		DRM_INFO("warning crtc has no fb, crtc id=%x\n", iga_path);
		return;
	}
	bits_per_pixel = fb->bits_per_pixel;

	if (BPP8 == bits_per_pixel)
		via_chrome9_set_lut(crtc);
	/* Note:
	*   It is probably VT3409 hardware issue,
	*   when we enable IGA1 gamma,
	*   the display color will become bad if playing video.
	*   Solution: disable IGA1 gamma on VT3409 (16/32bpp)
	*/
	else if ((iga_path != IGA1) || (dev->pci_device != VX855_DEVICE))
		via_chrome9_set_gamma(crtc);
}

void via_chrome9_crtc_load_lut(struct drm_crtc *crtc)
{
	via_chrome9_set_gamma_or_lut(crtc);
}

void via_chrome9_crtc_dpms(struct drm_crtc *crtc, int mode)
{
	struct via_chrome9_crtc *via_chrome9_crtc = to_via_chrome9_crtc(crtc);
	struct drm_device *dev = crtc->dev;

	switch (mode) {
	case DRM_MODE_DPMS_ON:
		if (via_chrome9_crtc->crtc_id) {
			via_chrome9_enable_secdisp_channel();
			via_chrome9_write_vga_io_bits(REG_CR6B, 0x00, BIT2);
		} else {
			via_chrome9_write_vga_io_bits(REG_SR01, 0x00, BIT5);
		}
		/* disable simultaneous  */
		via_chrome9_write_vga_io_bits(REG_CR6B, 0x00, BIT3);
		via_chrome9_crtc_load_lut(crtc);
		via_chrome9_crtc->enabled = true;
		break;
	case DRM_MODE_DPMS_STANDBY:
	case DRM_MODE_DPMS_SUSPEND:
	case DRM_MODE_DPMS_OFF:
		if (dev->num_crtcs)
			drm_vblank_pre_modeset(dev, via_chrome9_crtc->crtc_id);
		if (via_chrome9_crtc->crtc_id) {
			/* a. Disable IGA2 input data and display channel */
			via_chrome9_write_vga_io_bits(REG_CR6B, BIT2, BIT2);
			via_chrome9_disable_secdisp_channel();
			/* clear CR6C every time for tv clock */
			via_chrome9_write_vga_io_bits(REG_CR6C, 0x00, 0x0F);
		} else {
			/* Disable IGA1 input data */
			via_chrome9_write_vga_io_bits(REG_SR01, BIT5, BIT5);
			/* clear CR6C every time for tv clock */
			via_chrome9_write_vga_io_bits(REG_CR6C, 0x00, 0xF0);
		}
		via_chrome9_crtc->enabled = false;
		break;
	}
}

static bool via_chrome9_crtc_mode_fixup(struct drm_crtc *crtc,
		struct drm_display_mode *mode,
		struct drm_display_mode *adjusted_mode)
{
	return true;
}

static int via_chrome9_crtc_mode_set(struct drm_crtc *crtc,
		struct drm_display_mode *mode,
		struct drm_display_mode *adjusted_mode,
		int x, int y,
		struct drm_framebuffer *old_fb)
{
	int ret;

	ret = via_chrome9_crtc_set_base(crtc, x, y, old_fb);
	if (ret) {
		KMS_DEBUG("can not set the base!\n");
		return ret;
	}
	if (!via_chrome9_set_iga_timing(crtc, mode, adjusted_mode)) {
		KMS_DEBUG("can not set the timming!\n");
		return -1;
	}

	return 0;
}

int via_chrome9_crtc_set_base(struct drm_crtc *crtc, int x, int y,
		struct drm_framebuffer *old_fb)
{
	return via_chrome9_crtc_do_set_base(crtc, old_fb, x, y, 0);
}

int via_chrome9_crtc_set_base_atomic(struct drm_crtc *crtc,
		struct drm_framebuffer *fb,
		int x, int y,
		enum mode_set_atomic state)
{
	return 0;
}

void via_chrome9_set_iga_start_addr(struct drm_crtc *crtc,
		struct drm_framebuffer *drm_fb,
		u64 gpu_addr, int x, int y)
{
	struct via_chrome9_crtc *via_chrome9_crtc = to_via_chrome9_crtc(crtc);
	unsigned int start_addr = 0;
	int pitch = drm_fb->pitch;
	int bits_per_pixel = drm_fb->bits_per_pixel;
	int iga_path = via_chrome9_crtc->crtc_id;

	start_addr = gpu_addr + (pitch * y) + x * (bits_per_pixel / 8);
	if (IGA1 == iga_path) {
		start_addr = start_addr >> 1;
		via_chrome9_write_vga_io(REG_CR0D,
			(u8)(start_addr & 0x000000FF));
		via_chrome9_write_vga_io(REG_CR0C,
			(u8)((start_addr & 0x0000FF00) >> 8));
		via_chrome9_write_vga_io_bits(REG_CR48,
			(u8)((start_addr & 0xFF000000) >> 24) & 0x1f, 0x1f);
		/*Note: For 353,the register 3X5.48, 3x5.0C, 3x5.0D, 3x5.EC
		must ready before 3x5.34*/
		via_chrome9_write_vga_io(REG_CR34,
			(u8)((start_addr & 0x00FF0000) >> 16));
	} else {
		start_addr = start_addr >> 3;
		via_chrome9_write_vga_io_bits(REG_CR62,
			(u8)((start_addr & 0x0000007F) << 1), 0xFE);
		via_chrome9_write_vga_io(REG_CR63,
			(u8)((start_addr & 0x00007F80) >> 7));
		via_chrome9_write_vga_io(REG_CR64,
			(u8)((start_addr & 0x007F8000) >> 15));
		via_chrome9_write_vga_io(REG_CRA3,
			(u8)((start_addr & 0x03800000) >> 23));
	}
}

int via_chrome9_crtc_do_set_base(struct drm_crtc *crtc,
		struct drm_framebuffer *fb,
		int x, int y, int atomic)
{
	struct via_chrome9_framebuffer *via_chrome9_fb;
	struct via_chrome9_crtc *via_chrome9_crtc = to_via_chrome9_crtc(crtc);
	int iga_path = via_chrome9_crtc->crtc_id;
	struct drm_framebuffer *drm_fb;
	struct drm_gem_object *gobj;
	struct via_chrome9_object *vbo;
	u64 gpu_addr;
	int ret;
	u32 offset = 0;
	u32 fetch_count = 0;

	if (iga_path != IGA1 && iga_path != IGA2)
		return false;

	KMS_DEBUG("\n");
	if (!atomic && !crtc->fb) {
		KMS_DEBUG("there is no FB find\n");
		return -1;
	}

	if (atomic) {
		via_chrome9_fb = to_via_chrome9_framebuffer(fb);
		drm_fb = fb;
	} else {
		via_chrome9_fb = to_via_chrome9_framebuffer(crtc->fb);
		drm_fb = crtc->fb;
	}

	KMS_DEBUG(
		"width=%d  height=%d  pitch=%d \
		bits_per_pixel=%d depth=%d\n",
		drm_fb->width, drm_fb->height,
		drm_fb->pitch, drm_fb->bits_per_pixel, drm_fb->depth);

	gobj = via_chrome9_fb->obj;
	vbo = gobj->driver_private;
	ret = via_chrome9_bo_pin(vbo, TTM_PL_FLAG_VRAM, &gpu_addr);
	if (unlikely(ret != 0)) {
		KMS_DEBUG("pin the bo error\n");
		return -EINVAL;
	}

	KMS_DEBUG("gpu_addr=%llx , x=%d , y=%d\n", gpu_addr, x, y);
	via_chrome9_set_iga_start_addr(crtc, drm_fb, gpu_addr, x, y);

	offset = CMDISP_ALIGN_TO(drm_fb->pitch, 16) / 8;
	via_chrome9_load_offset_regs(crtc, offset);

	/* Load fetch count register */
	fetch_count = CMDISP_ALIGN_TO(
		crtc->mode.hdisplay *
		drm_fb->bits_per_pixel / 8,
		16) / 16;
	fetch_count += 1;
	via_chrome9_load_fetch_count_regs(crtc, fetch_count);
	/* Load FIFO */
	via_chrome9_load_fifo_regs(crtc, crtc->mode.hdisplay,
		crtc->mode.vdisplay);

	/* Load color depth */
	via_chrome9_load_color_depth_regs(crtc, drm_fb->bits_per_pixel);

	KMS_DEBUG(" mode hdisplay = %d, mode vdisplay = %d\n",
		crtc->mode.hdisplay, crtc->mode.vdisplay);
	KMS_DEBUG(" offset = %d, fetchcount=%d, pixelformat=%d\n",
		offset, fetch_count, drm_fb->bits_per_pixel);

	return 0;
}

static void via_chrome9_crtc_prepare(struct drm_crtc *crtc)
{
	if (crtc->enabled)
		via_chrome9_crtc_dpms(crtc, DRM_MODE_DPMS_OFF);
}

static void via_chrome9_crtc_commit(struct drm_crtc *crtc)
{
	if (crtc->enabled)
		via_chrome9_crtc_dpms(crtc, DRM_MODE_DPMS_ON);
}

static void via_chrome9_crtc_gamma_set(struct drm_crtc *crtc, u16 *red,
		u16 *green, u16 *blue,
		uint32_t start, uint32_t size)
{
	struct via_chrome9_crtc *via_chrome9_crtc = to_via_chrome9_crtc(crtc);
	int end = (start + size > 256) ? 256 : start + size, i;

	/* userspace palettes are always correct as is */
	/* this should be study later */
	for (i = start; i < end; i++) {
		via_chrome9_crtc->lut_r[i] = red[i] >> 8;
		via_chrome9_crtc->lut_g[i] = green[i] >> 8;
		via_chrome9_crtc->lut_b[i] = blue[i] >> 8;
	}

	via_chrome9_set_gamma_or_lut(crtc);
}

static void via_chrome9_crtc_destroy(struct drm_crtc *crtc)
{
	struct via_chrome9_crtc *via_chrome9_crtc = to_via_chrome9_crtc(crtc);

	drm_crtc_cleanup(crtc);
	kfree(via_chrome9_crtc);
}

static const struct drm_crtc_funcs via_chrome9_crtc_funcs = {
	.cursor_set = via_chrome9_crtc_cursor_set,
	.cursor_move = via_chrome9_crtc_cursor_move,
	.gamma_set = via_chrome9_crtc_gamma_set,
	.set_config = drm_crtc_helper_set_config,
	.destroy = via_chrome9_crtc_destroy,
};

static const struct drm_crtc_helper_funcs via_chrome9_crtc_helper_funcs = {
	.dpms = via_chrome9_crtc_dpms,
	.mode_fixup = via_chrome9_crtc_mode_fixup,
	.mode_set = via_chrome9_crtc_mode_set,
	.mode_set_base = via_chrome9_crtc_set_base,
	.mode_set_base_atomic = via_chrome9_crtc_set_base_atomic,
	.prepare = via_chrome9_crtc_prepare,
	.commit = via_chrome9_crtc_commit,
	.load_lut = via_chrome9_crtc_load_lut,
};

void via_chrome9_crtc_init(struct drm_device *dev, int index)
{
	struct drm_via_chrome9_private *p_priv =
		(struct drm_via_chrome9_private *)dev->dev_private;
	struct via_chrome9_crtc *via_chrome9_crtc;
	int i;

	via_chrome9_crtc =
		kzalloc(sizeof(struct via_chrome9_crtc) +
		(4 * sizeof(struct drm_connector *)), GFP_KERNEL);
	if (via_chrome9_crtc == NULL)
		return;

	drm_crtc_init(dev, &via_chrome9_crtc->base, &via_chrome9_crtc_funcs);
	drm_crtc_helper_add(&via_chrome9_crtc->base,
		&via_chrome9_crtc_helper_funcs);

	drm_mode_crtc_set_gamma_size(&via_chrome9_crtc->base, 256);
	via_chrome9_crtc->crtc_id = index;
	p_priv->mode_info.crtcs[index] = via_chrome9_crtc;
	for (i = 0; i < 256; i++) {
		via_chrome9_crtc->lut_r[i] = i << 8 | i;
		via_chrome9_crtc->lut_g[i] = i << 8 | i;
		via_chrome9_crtc->lut_b[i] = i << 8 | i;
	}
}
