/*
 * Copyright 1998-2003 VIA Technologies, Inc. All Rights Reserved.
 * Copyright 2001-2003 S3 Graphics, Inc. All Rights Reserved.
 *
 * Permission is hereby granted, free of charge, to any person
 * obtaining a copy of this software and associated documentation
 * files (the "Software"), to deal in the Software without
 * restriction, including without limitation the rights to use,
 * copy, modify, merge, publish, distribute, sub license,
 * and/or sell copies of the Software, and to permit persons to
 * whom the Software is furnished to do so, subject to the
 * following conditions:
 *
 * The above copyright notice and this permission notice
 * (including the next paragraph) shall be included in all
 * copies or substantial portions of the Software.
 *
 * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND,
 * EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES
 * OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND
 * NON-INFRINGEMENT. IN NO EVENT SHALL VIA, S3 GRAPHICS, AND/OR
 * ITS SUPPLIERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
 * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE,
 * ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR
 * THE USE OR OTHER DEALINGS IN THE SOFTWARE.
 */
#ifndef _VIA_CHROME9_HDAC_PATCH_H_
#define _VIA_CHROME9_HDAC_PATCH_H_

#include<linux/timer.h>
#include "via_chrome9_drv.h"

#define HDAC_PATCH_TIMER_ENABLE 1

#if HDAC_PATCH_TIMER_ENABLE
	#define CTS_PATCH_ON()  via_chrome9_hdac_cts_patch_open()
	#define CTS_PATCH_OFF()  via_chrome9_hdac_cts_patch_close()
#else
	#define CTS_PATCH_ON()
	#define CTS_PATCH_OFF()
#endif

extern void via_chrome9_hdac_cts_patch_open(void);
extern void via_chrome9_hdac_cts_patch_close(void);

extern u8 via_chrome9_set_HDAudio_CTS_N(u32 hdacSampleRate,
		u32 hdacPixelClock);
extern u8 via_chrome9_set_HDAudio_sample_rate(u32 hdacSampleRate,
		u32 hdacPixelClock);

#endif

