 /*
  * This copyright notice applies to this header file:
  *
  * Copyright (c) 2008 NVIDIA Corporation
  * 
  * Permission is hereby granted, free of charge, to any person
  * obtaining a copy of this software and associated documentation
  * files (the "Software"), to deal in the Software without
  * restriction, including without limitation the rights to use,
  * copy, modify, merge, publish, distribute, sublicense, and/or sell
  * copies of the Software, and to permit persons to whom the
  * Software is furnished to do so, subject to the following
  * conditions:
  *
  * The above copyright notice and this permission notice shall be
  * included in all copies or substantial portions of the Software.
  *
  * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND,
  * EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES
  * OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND
  * NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT
  * HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY,
  * WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING
  * FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR
  * OTHER DEALINGS IN THE SOFTWARE.
  */
 
 #ifndef _VDPAU_X11_H
 #define _VDPAU_X11_H
 
 #include <X11/Xlib.h>
 #include "vdpau.h"
 
 #ifdef __cplusplus
 extern "C" {
 #endif
 
 typedef VdpStatus VdpDeviceCreateX11(
     Display *             display,
     int                   screen,
     /* output parameters follow */
     VdpDevice *           device,
     VdpGetProcAddress * * get_proc_address
 );
 
 VdpDeviceCreateX11 vdp_device_create_x11;
 
 typedef VdpStatus VdpPresentationQueueTargetCreateX11(
     VdpDevice                   device,
     Drawable                    drawable,
     /* output parameters follow */
     VdpPresentationQueueTarget * target
 );
 
 #define VDP_FUNC_ID_PRESENTATION_QUEUE_TARGET_CREATE_X11 (VdpFuncId)(VDP_FUNC_ID_BASE_WINSYS + 0)
 
 
 #ifdef __cplusplus
 }
 #endif
 
 #endif 

